/* Generated by re2c 0.13.5 on Thu Jun 16 18:07:55 2011 */
#line 1 "src/scanner.re"
/*
 * scanner.re
 *
 *   Copyright (c) 2008  Higepon(Taro Minowa)  <higepon@users.sourceforge.jp>
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions
 *   are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  $Id: Reader.y 183 2008-07-04 06:19:28Z higepon $
 */
#include <stdio.h>
#include "Object.h"
#include "Pair.h"
#include "StringProcedures.h"
#include "TextualInputPort.h"
#include "TextualOutputPort.h"
#include "EqHashTable.h"
#include "ucs4string.h"
#include "ScannerHelper.h"
#include "Scanner.h"
#include "OSCompatThread.h"
#include "VM.h"
#include "MultiVMProcedures.h"

#define YYCTYPE ucs4char
#define YYCURSOR cursor_
#define YYMARKER marker_
#define YYLIMIT limit_
#define YYTOKEN token_
#define YYDEBUG(state, ch)  yydebug(state, ch)
#define YYFILL(n) fill(n)

using namespace scheme;

Scanner::Scanner() : eofP_(false),
                     buffer_(NULL),
                     cursor_(buffer_),
                     token_(buffer_),
                     limit_(buffer_),
                     marker_(buffer_),
                     bufferSize_(32)
{
}

Scanner::~Scanner()
{
}

// Since re2c greedy look-aheads,
// we need to give back read buffer to input-port.
void Scanner::emptyBuffer()
{
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();

    for (ucs4char* p = limit_ - 1; p >= cursor_; p--) {
        // special case
        if (eofP_ && p == limit_ - 1 && *p == '\0') {
            continue;
        } else {
            inputPort->unGetChar(*p);
        }
    }

    // even if port reaches EOF, we turns off this flag.
    // fill() will detect EOF.
    eofP_ = false;
    cursor_ = buffer_;
    limit_ = buffer_;
    token_ = buffer_;
    marker_ = buffer_;
}

void Scanner::fill(int n)
{
    if (eofP_) return;
    TextualInputPort* const inputPort = currentVM()->readerContext()->port();
    const int restCharCount = limit_ - token_;
    const int tokenOffset = token_ - buffer_;

    if (buffer_ == NULL) {
        buffer_ = new(GC) ucs4char[bufferSize_];
        cursor_ = buffer_;
        limit_ = buffer_;
        token_ = buffer_;
        marker_ = buffer_;
    }

    if ((restCharCount + n) > bufferSize_) {
        ucs4char* newBuffer = new(GC) ucs4char[restCharCount + n + 1];
        bufferSize_ = restCharCount + n + 1;
        memmove(newBuffer, token_, restCharCount * sizeof(ucs4char));
        cursor_ = &newBuffer[cursor_ - buffer_];
        token_ = &newBuffer[token_ - buffer_];
        limit_ = &newBuffer[limit_ - buffer_];
        marker_ = &newBuffer[marker_ - buffer_];
        buffer_ = newBuffer;
    } else if (restCharCount > 0) {
        memmove(buffer_, token_, restCharCount * sizeof(ucs4char));
    }

    int i;
    for (i = 0; i < n; i++) {
        const ucs4char ch = inputPort->getChar();
        if (ch == EOF) {
            eofP_ = true;
            buffer_[i + restCharCount] = '\0';
            i++;
            break;
        } else {
            buffer_[i + restCharCount] = ch;
        }
//         if (!inputPort->isDataReady()) {
//             i++;
//
//             break;
//         }

    }
    const int readSize = i;
    cursor_ = cursor_ - tokenOffset;
    token_ = buffer_;
    marker_ = marker_ - tokenOffset;
    limit_ = limit_ - tokenOffset + readSize;
}

int yylex(YYSTYPE* yylval)
{
    return currentVM()->readerContext()->port()->scanner()->scan(yylval);
}

int Scanner::scan(YYSTYPE* yylval)
{
#line 228 "src/scanner.re"


    int comment_count = 0;

    for(;;)
    {

#line 164 "<stdout>"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;

	if ((YYLIMIT - YYCURSOR) < 18) YYFILL(18);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy23;
					if (yych <= 0x00000008) goto yy25;
					goto yy22;
				} else {
					if (yych <= 0x0000001F) goto yy25;
					if (yych <= ' ') goto yy22;
					goto yy9;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '"') goto yy13;
					if (yych >= '$') goto yy9;
				} else {
					if (yych <= '\'') goto yy15;
					if (yych <= '(') goto yy20;
					if (yych <= ')') goto yy18;
					goto yy9;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= '+') goto yy4;
					if (yych <= ',') goto yy16;
					goto yy5;
				} else {
					if (yych <= '.') goto yy7;
					if (yych <= '/') goto yy9;
					goto yy6;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy17;
					goto yy9;
				} else {
					if (yych <= '@') goto yy8;
					if (yych <= 'Z') goto yy9;
					if (yych <= '[') goto yy20;
					goto yy12;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= '`') {
					if (yych <= ']') goto yy18;
					if (yych <= '_') goto yy9;
					goto yy14;
				} else {
					if (yych <= 'z') goto yy9;
					if (yych <= '}') goto yy25;
					goto yy9;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy25;
					if (yych <= 0x00000084) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x000000A0) goto yy10;
					if (yych <= 0x0000167F) goto yy9;
					goto yy10;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy10;
					goto yy9;
				} else {
					if (yych <= 0x0000200A) goto yy10;
					if (yych <= 0x00002027) goto yy9;
					if (yych <= 0x00002029) goto yy10;
					goto yy9;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy10;
					if (yych <= 0x0000205E) goto yy9;
					goto yy10;
				} else {
					if (yych == 0x00003000) goto yy10;
					if (yych <= 0x0000FFFF) goto yy9;
					goto yy25;
				}
			}
		}
	}
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '!':	goto yy353;
	case '\'':	goto yy356;
	case '(':	goto yy351;
	case ',':	goto yy354;
	case '/':	goto yy357;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy366;
	case ';':	goto yy348;
	case 'B':
	case 'b':	goto yy363;
	case 'D':
	case 'd':	goto yy362;
	case 'E':
	case 'I':
	case 'e':
	case 'i':	goto yy360;
	case 'F':
	case 'f':	goto yy365;
	case 'O':
	case 'o':	goto yy361;
	case 'T':
	case 't':	goto yy368;
	case 'X':
	case 'x':	goto yy359;
	case '\\':	goto yy364;
	case '`':	goto yy355;
	case 'v':	goto yy350;
	case '|':	goto yy346;
	default:	goto yy3;
	}
yy3:
#line 477 "src/scanner.re"
	{
            // syntax error
            return 0;
        }
#line 311 "<stdout>"
yy4:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy3;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy3;
					goto yy66;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy3;
					goto yy66;
				} else {
					if (yych <= '\'') goto yy3;
					if (yych <= ')') goto yy66;
					goto yy3;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy310;
					goto yy3;
				} else {
					if (yych <= '9') goto yy313;
					if (yych <= ':') goto yy3;
					goto yy66;
				}
			} else {
				if (yych <= '\\') {
					if (yych == '[') goto yy66;
					goto yy3;
				} else {
					if (yych <= ']') goto yy66;
					if (yych <= 'h') goto yy3;
					goto yy311;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'n') {
					if (yych <= 'm') goto yy3;
					goto yy312;
				} else {
					if (yych == 0x00000085) goto yy66;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy66;
					goto yy3;
				} else {
					if (yych <= 0x00001680) goto yy66;
					if (yych <= 0x0000180D) goto yy3;
					goto yy66;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy3;
					goto yy66;
				} else {
					if (yych <= 0x00002027) goto yy3;
					if (yych <= 0x00002029) goto yy66;
					goto yy3;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy66;
					if (yych <= 0x0000205E) goto yy3;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy3;
				}
			}
		}
	}
yy5:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '=') {
		if (yych <= '\'') {
			if (yych <= '\r') {
				if (yych <= 0x00000000) goto yy61;
				if (yych <= 0x00000008) goto yy3;
				goto yy61;
			} else {
				if (yych <= 0x0000001F) goto yy3;
				if (yych <= '&') goto yy61;
				goto yy3;
			}
		} else {
			if (yych <= '-') {
				if (yych == ',') goto yy3;
				goto yy61;
			} else {
				if (yych <= '.') goto yy188;
				if (yych <= '/') goto yy61;
				if (yych <= '9') goto yy189;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'm') {
			if (yych <= '`') {
				if (yych <= '>') goto yy186;
				if (yych <= '_') goto yy61;
				goto yy3;
			} else {
				if (yych == 'i') goto yy191;
				goto yy61;
			}
		} else {
			if (yych <= '}') {
				if (yych <= 'n') goto yy192;
				if (yych <= 'z') goto yy61;
				goto yy3;
			} else {
				if (yych == 0x0000007F) goto yy3;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy3;
			}
		}
	}
yy6:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy168;
					if (yych <= 0x00000008) goto yy3;
					goto yy168;
				} else {
					if (yych == ' ') goto yy168;
					goto yy3;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy168;
					if (yych <= '\'') goto yy3;
					goto yy168;
				} else {
					if (yych == '+') goto yy168;
					if (yych <= ',') goto yy3;
					goto yy168;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych == ';') goto yy168;
					goto yy3;
				} else {
					if (yych <= '@') goto yy168;
					if (yych <= 'C') goto yy3;
					if (yych <= 'F') goto yy168;
					goto yy3;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy168;
					if (yych <= 'R') goto yy3;
					goto yy168;
				} else {
					if (yych == '[') goto yy168;
					if (yych <= '\\') goto yy3;
					goto yy168;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy3;
					if (yych <= 'f') goto yy168;
					goto yy3;
				} else {
					if (yych <= 'l') goto yy168;
					if (yych <= 'r') goto yy3;
					goto yy168;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '|') goto yy168;
					goto yy3;
				} else {
					if (yych <= 0x00000085) goto yy168;
					if (yych == 0x000000A0) goto yy168;
					goto yy3;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy168;
					if (yych <= 0x0000180D) goto yy3;
					goto yy168;
				} else {
					if (yych <= 0x00001FFF) goto yy3;
					if (yych <= 0x0000200A) goto yy168;
					if (yych <= 0x00002027) goto yy3;
					goto yy168;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy168;
					goto yy3;
				} else {
					if (yych <= 0x0000205F) goto yy168;
					if (yych == 0x00003000) goto yy168;
					goto yy3;
				}
			}
		}
	}
yy7:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy70;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy70;
				goto yy3;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy70;
					goto yy3;
				} else {
					if (yych <= '#') goto yy70;
					if (yych <= '\'') goto yy3;
					goto yy70;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy3;
					goto yy72;
				} else {
					if (yych <= '/') goto yy3;
					if (yych <= '9') goto yy73;
					goto yy3;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy70;
					goto yy3;
				} else {
					if (yych == '\\') goto yy3;
					goto yy70;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy70;
				if (yych <= 0x0000009F) goto yy3;
				goto yy70;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy3;
					goto yy70;
				} else {
					if (yych == 0x0000180E) goto yy70;
					goto yy3;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy70;
					goto yy3;
				} else {
					if (yych <= 0x00002029) goto yy70;
					if (yych <= 0x0000202E) goto yy3;
					goto yy70;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy70;
				} else {
					if (yych == 0x00003000) goto yy70;
					goto yy3;
				}
			}
		}
	}
yy8:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy66;
				if (yych <= 0x00000008) goto yy3;
				if (yych <= '\r') goto yy66;
				goto yy3;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy66;
					goto yy3;
				} else {
					if (yych <= '#') goto yy66;
					if (yych <= '\'') goto yy3;
					goto yy66;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy66;
				if (yych <= ':') goto yy3;
				goto yy66;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy3;
					goto yy66;
				} else {
					if (yych == ']') goto yy66;
					goto yy3;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy66;
				if (yych == 0x000000A0) goto yy66;
				goto yy3;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy66;
					goto yy3;
				} else {
					if (yych <= 0x0000180E) goto yy66;
					if (yych <= 0x00001FFF) goto yy3;
					goto yy66;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy3;
				if (yych <= 0x00002029) goto yy66;
				if (yych <= 0x0000202E) goto yy3;
				goto yy66;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy3;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy3;
				}
			}
		}
	}
yy9:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy3;
			if (yych <= '\r') goto yy61;
			goto yy3;
		} else {
			if (yych == '\'') goto yy3;
			if (yych <= '+') goto yy61;
			goto yy3;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy3;
			if (yych <= 'z') goto yy61;
			goto yy3;
		} else {
			if (yych == 0x0000007F) goto yy3;
			if (yych <= 0x0000FFFF) goto yy61;
			goto yy3;
		}
	}
yy10:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy11;
			if (yych <= '\r') goto yy61;
		} else {
			if (yych == '\'') goto yy11;
			if (yych <= '+') goto yy61;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy11;
			if (yych <= 'z') goto yy61;
		} else {
			if (yych == 0x0000007F) goto yy11;
			if (yych <= 0x0000FFFF) goto yy61;
		}
	}
yy11:
#line 461 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 735 "<stdout>"
yy12:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'x') goto yy57;
	goto yy3;
yy13:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy44;
yy14:
	yych = *++YYCURSOR;
	goto yy41;
yy15:
	yych = *++YYCURSOR;
	goto yy39;
yy16:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy36;
	goto yy34;
yy17:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy27;
yy18:
	++YYCURSOR;
#line 443 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return RIGHT_PAREN;
        }
#line 767 "<stdout>"
yy20:
	++YYCURSOR;
#line 448 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[0];
            YYTOKEN = YYCURSOR;
            return LEFT_PAREN;
        }
#line 776 "<stdout>"
yy22:
	yych = *++YYCURSOR;
	goto yy11;
yy23:
	++YYCURSOR;
#line 465 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return END_OF_FILE;
        }
#line 787 "<stdout>"
yy25:
	yych = *++YYCURSOR;
	goto yy3;
yy26:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy27:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy28:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy33;
			goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy30:
#line 439 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            continue;
        }
#line 842 "<stdout>"
yy31:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych >= 0x00000001) goto yy26;
		} else {
			if (yych <= '\n') goto yy33;
			if (yych <= '\f') goto yy26;
			goto yy28;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy26;
			goto yy31;
		} else {
			if (yych == 0x00002028) goto yy31;
			goto yy26;
		}
	}
yy33:
	yych = *++YYCURSOR;
	goto yy30;
yy34:
	++YYCURSOR;
#line 417 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTE; }
#line 875 "<stdout>"
yy36:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 412 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNQUOTESPLICING;
        }
#line 885 "<stdout>"
yy39:
	++YYCURSOR;
#line 407 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUOTE;
        }
#line 894 "<stdout>"
yy41:
	++YYCURSOR;
#line 402 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASIQUOTE;
        }
#line 903 "<stdout>"
yy43:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy44:
	if (yych == '"') goto yy47;
	if (yych != '\\') goto yy43;
yy45:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'u') {
		if (yych <= '\\') {
			if (yych <= '\r') {
				if (yych <= '\t') {
					if (yych >= '\t') goto yy50;
				} else {
					if (yych <= '\n') goto yy52;
					if (yych >= '\r') goto yy54;
				}
			} else {
				if (yych <= '!') {
					if (yych == ' ') goto yy50;
				} else {
					if (yych <= '"') goto yy43;
					if (yych >= '\\') goto yy43;
				}
			}
		} else {
			if (yych <= 'm') {
				if (yych <= 'b') {
					if (yych >= 'a') goto yy43;
				} else {
					if (yych == 'f') goto yy43;
				}
			} else {
				if (yych <= 'r') {
					if (yych <= 'n') goto yy43;
					if (yych >= 'r') goto yy43;
				} else {
					if (yych == 't') goto yy43;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'w') {
					if (yych <= 'v') goto yy43;
				} else {
					if (yych <= 'x') goto yy49;
					if (yych >= 0x00000085) goto yy52;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy50;
				} else {
					if (yych <= 0x00001680) goto yy50;
					if (yych >= 0x0000180E) goto yy50;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych >= 0x00002000) goto yy50;
				} else {
					if (yych == 0x00002028) goto yy52;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy50;
					if (yych >= 0x0000205F) goto yy50;
				} else {
					if (yych == 0x00003000) goto yy50;
				}
			}
		}
	}
yy46:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 4) {
		if (yyaccept <= 2) {
			if (yyaccept <= 1) {
				if (yyaccept <= 0) {
					goto yy3;
				} else {
					goto yy11;
				}
			} else {
				goto yy30;
			}
		} else {
			if (yyaccept <= 3) {
				goto yy64;
			} else {
				goto yy71;
			}
		}
	} else {
		if (yyaccept <= 6) {
			if (yyaccept <= 5) {
				goto yy78;
			} else {
				goto yy598;
			}
		} else {
			if (yyaccept <= 7) {
				goto yy761;
			} else {
				goto yy781;
			}
		}
	}
yy47:
	++YYCURSOR;
#line 392 "src/scanner.re"
	{
            yylval->stringValue = ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN) - 2);
            YYTOKEN = YYCURSOR;
            return STRING;
        }
#line 1025 "<stdout>"
yy49:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy55;
		goto yy46;
	} else {
		if (yych <= 'F') goto yy55;
		if (yych <= '`') goto yy46;
		if (yych <= 'f') goto yy55;
		goto yy46;
	}
yy50:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x00001680) {
		if (yych <= 0x0000001F) {
			if (yych <= '\n') {
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\t') goto yy50;
			} else {
				if (yych == '\r') goto yy54;
				goto yy46;
			}
		} else {
			if (yych <= 0x00000085) {
				if (yych <= ' ') goto yy50;
				if (yych <= 0x00000084) goto yy46;
			} else {
				if (yych == 0x000000A0) goto yy50;
				if (yych <= 0x0000167F) goto yy46;
				goto yy50;
			}
		}
	} else {
		if (yych <= 0x00002028) {
			if (yych <= 0x00001FFF) {
				if (yych == 0x0000180E) goto yy50;
				goto yy46;
			} else {
				if (yych <= 0x0000200A) goto yy50;
				if (yych <= 0x00002027) goto yy46;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy50;
				goto yy46;
			} else {
				if (yych <= 0x0000205F) goto yy50;
				if (yych == 0x00003000) goto yy50;
				goto yy46;
			}
		}
	}
yy52:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x0000167F) {
		if (yych <= '!') {
			if (yych <= '\t') {
				if (yych <= 0x00000008) goto yy43;
				goto yy52;
			} else {
				if (yych == ' ') goto yy52;
				goto yy43;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '"') goto yy47;
				if (yych <= '[') goto yy43;
				goto yy45;
			} else {
				if (yych == 0x000000A0) goto yy52;
				goto yy43;
			}
		}
	} else {
		if (yych <= 0x0000202E) {
			if (yych <= 0x0000180E) {
				if (yych <= 0x00001680) goto yy52;
				if (yych <= 0x0000180D) goto yy43;
				goto yy52;
			} else {
				if (yych <= 0x00001FFF) goto yy43;
				if (yych <= 0x0000200A) goto yy52;
				goto yy43;
			}
		} else {
			if (yych <= 0x0000205F) {
				if (yych <= 0x0000202F) goto yy52;
				if (yych <= 0x0000205E) goto yy43;
				goto yy52;
			} else {
				if (yych == 0x00003000) goto yy52;
				goto yy43;
			}
		}
	}
yy54:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 0x000000A0) {
		if (yych <= '"') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000008) goto yy43;
				if (yych <= '\n') goto yy52;
				goto yy43;
			} else {
				if (yych <= ' ') goto yy52;
				if (yych <= '!') goto yy43;
				goto yy47;
			}
		} else {
			if (yych <= 0x00000084) {
				if (yych == '\\') goto yy45;
				goto yy43;
			} else {
				if (yych <= 0x00000085) goto yy52;
				if (yych <= 0x0000009F) goto yy43;
				goto yy52;
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000180D) {
				if (yych == 0x00001680) goto yy52;
				goto yy43;
			} else {
				if (yych <= 0x0000180E) goto yy52;
				if (yych <= 0x00001FFF) goto yy43;
				goto yy52;
			}
		} else {
			if (yych <= 0x0000205E) {
				if (yych == 0x0000202F) goto yy52;
				goto yy43;
			} else {
				if (yych <= 0x0000205F) goto yy52;
				if (yych == 0x00003000) goto yy52;
				goto yy43;
			}
		}
	}
yy55:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy55;
		if (yych <= ':') goto yy46;
		goto yy43;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy55;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy55;
			goto yy46;
		}
	}
yy57:
	yych = *++YYCURSOR;
	if (yych == ';') goto yy46;
	goto yy59;
yy58:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy59:
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy58;
		if (yych <= ':') goto yy46;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy58;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy58;
			goto yy46;
		}
	}
yy60:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy61:
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy46;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy60;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych != 0x000000A0) goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych >= 0x0000200B) goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy62;
					if (yych <= 0x0000202E) goto yy60;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych != 0x0000205F) goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy62:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych >= ' ') goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				} else {
					if (yych <= '\'') goto yy64;
					if (yych <= ')') goto yy66;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy64;
					if (yych <= '-') goto yy60;
					goto yy62;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych != '`') goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych >= '~') goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy64;
					if (yych <= 0x00000084) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy62;
					if (yych <= 0x0000202E) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
				}
			}
		}
	}
yy64:
#line 380 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
            YYTOKEN = YYCURSOR;
            return IDENTIFIER;
            }
#line 1394 "<stdout>"
yy65:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == 'x') goto yy67;
	goto yy46;
yy66:
	yych = *++YYCURSOR;
	goto yy64;
yy67:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy68;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy68:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy68;
		if (yych <= ':') goto yy46;
		goto yy60;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy68;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy68;
			goto yy46;
		}
	}
yy70:
	++YYCURSOR;
yy71:
#line 397 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return DOT;
        }
#line 1444 "<stdout>"
yy72:
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '.') goto yy165;
	goto yy71;
yy73:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy73;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy75;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy75;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy75;
					if (yych != 'l') goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy75;
					if (yych <= '{') goto yy46;
					goto yy76;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy75:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy162;
		goto yy46;
	} else {
		if (yych <= '-') goto yy162;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy163;
		goto yy46;
	}
yy76:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy160;
	goto yy46;
yy77:
	++YYCURSOR;
yy78:
#line 362 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 1570 "<stdout>"
yy79:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy121;
		if (yych <= ',') goto yy46;
		goto yy121;
	} else {
		if (yych <= '.') goto yy124;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy122;
		goto yy46;
	}
yy80:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy85;
		if (yych <= '/') goto yy46;
		goto yy83;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
		} else {
			if (yych == 'n') goto yy82;
			goto yy46;
		}
	}
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 'm') goto yy46;
					goto yy118;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy82:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy114;
	goto yy46;
yy83:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'C') {
			if (yych <= '.') {
				if (yych <= '-') goto yy46;
				goto yy96;
			} else {
				if (yych <= '/') goto yy98;
				if (yych <= '9') goto yy83;
				goto yy46;
			}
		} else {
			if (yych <= 'K') {
				if (yych <= 'F') goto yy97;
				goto yy46;
			} else {
				if (yych <= 'L') goto yy97;
				if (yych <= 'R') goto yy46;
				goto yy97;
			}
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'f') {
				if (yych <= 'c') goto yy46;
				goto yy97;
			} else {
				if (yych == 'i') goto yy90;
				goto yy46;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'l') goto yy97;
				if (yych <= 'r') goto yy46;
				goto yy97;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
yy85:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy86:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy86;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy46;
			} else {
				if (yych != 'S') goto yy46;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'h') {
				if (yych >= 'g') goto yy46;
			} else {
				if (yych <= 'i') goto yy90;
				if (yych <= 'k') goto yy46;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy46;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy93;
		goto yy46;
	} else {
		if (yych <= '-') goto yy93;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy94;
		goto yy46;
	}
yy89:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy91;
	goto yy46;
yy90:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy77;
				if (yych <= ':') goto yy46;
				goto yy77;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy77;
				if (yych == 0x000000A0) goto yy77;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy77;
				if (yych <= 0x0000202E) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy91:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy91;
	if (yych == 'i') goto yy90;
	goto yy46;
yy93:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy94:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy94;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy96:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy105;
			if (yych <= 'F') goto yy106;
			goto yy105;
		} else {
			if (yych <= 'L') goto yy106;
			if (yych <= 'R') goto yy105;
			goto yy106;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy105;
			if (yych <= 'f') goto yy106;
			goto yy105;
		} else {
			if (yych <= 'l') goto yy106;
			if (yych == 's') goto yy106;
			goto yy105;
		}
	}
yy97:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy101;
		goto yy46;
	} else {
		if (yych <= '-') goto yy101;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy102;
		goto yy46;
	}
yy98:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy99:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy99;
	if (yych == 'i') goto yy90;
	goto yy46;
yy101:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy102:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy102;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy104:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy105:
	if (yych <= 'c') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy104;
			if (yych <= 'C') goto yy46;
			goto yy110;
		} else {
			if (yych <= 'L') {
				if (yych <= 'K') goto yy46;
				goto yy110;
			} else {
				if (yych == 'S') goto yy110;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'l') {
			if (yych <= 'h') {
				if (yych <= 'f') goto yy110;
				goto yy46;
			} else {
				if (yych <= 'i') goto yy90;
				if (yych <= 'k') goto yy46;
				goto yy110;
			}
		} else {
			if (yych <= 's') {
				if (yych <= 'r') goto yy46;
				goto yy110;
			} else {
				if (yych == '|') goto yy89;
				goto yy46;
			}
		}
	}
yy106:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy107;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy108;
		goto yy46;
	}
yy107:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy108:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy108;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy110:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy111;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy112;
		goto yy46;
	}
yy111:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy112:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy112;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy90;
		if (yych == '|') goto yy89;
		goto yy46;
	}
yy114:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy117:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy90;
	goto yy46;
yy118:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy117;
	goto yy46;
yy121:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy124;
		if (yych <= '/') goto yy46;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy153;
		} else {
			if (yych == 'n') goto yy152;
			goto yy46;
		}
	}
yy122:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy134;
					if (yych <= '/') goto yy136;
					goto yy122;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'C') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'F') goto yy135;
					if (yych <= 'K') goto yy46;
					goto yy135;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == 'S') goto yy135;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					if (yych <= ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy135;
					if (yych <= 'k') goto yy46;
					goto yy135;
				} else {
					if (yych == 's') goto yy135;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= '|') goto yy128;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy124:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy125:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy125;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'C') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'F') goto yy127;
					if (yych <= 'K') goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych != 'S') goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					if (yych <= ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy127;
					if (yych <= 'k') goto yy46;
				} else {
					if (yych != 's') goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= '|') goto yy128;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy127:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy131;
		goto yy46;
	} else {
		if (yych <= '-') goto yy131;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy132;
		goto yy46;
	}
yy128:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy129:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy129;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy131:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy132:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy77;
					goto yy46;
				} else {
					if (yych <= '9') goto yy132;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= '|') goto yy128;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy134:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy78;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy78;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy78;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					if (yych <= '/') goto yy78;
					goto yy142;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'C') {
					if (yych == ';') goto yy77;
					goto yy78;
				} else {
					if (yych <= 'F') goto yy144;
					if (yych <= 'K') goto yy78;
					goto yy144;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == 'S') goto yy144;
					goto yy78;
				} else {
					if (yych == '\\') goto yy78;
					if (yych <= ']') goto yy77;
					goto yy78;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy144;
					if (yych <= 'k') goto yy78;
					goto yy144;
				} else {
					if (yych == 's') goto yy144;
					goto yy78;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= '|') goto yy128;
					if (yych <= 0x00000084) goto yy78;
					goto yy77;
				} else {
					if (yych == 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy78;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy78;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy78;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy78;
				}
			}
		}
	}
yy135:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy139;
		goto yy46;
	} else {
		if (yych <= '-') goto yy139;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy140;
		goto yy46;
	}
yy136:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy137:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy137;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy77;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy139:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy140:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy77;
					goto yy46;
				} else {
					if (yych <= '9') goto yy140;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= '|') goto yy128;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy142:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				} else {
					if (yych == '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy142;
				}
			}
		} else {
			if (yych <= 'L') {
				if (yych <= 'C') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'F') goto yy148;
					if (yych <= 'K') goto yy46;
					goto yy148;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == 'S') goto yy148;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					if (yych <= ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy148;
					if (yych <= 'k') goto yy46;
					goto yy148;
				} else {
					if (yych == 's') goto yy148;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= '|') goto yy128;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x000000A0) goto yy77;
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy77;
					if (yych <= 0x00002027) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy144:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy145;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy146;
		goto yy46;
	}
yy145:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy146:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy77;
					goto yy46;
				} else {
					if (yych <= '9') goto yy146;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= '|') goto yy128;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy148:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy149;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy150;
		goto yy46;
	}
yy149:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy150:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '{') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy77;
					goto yy46;
				} else {
					if (yych <= '9') goto yy150;
					if (yych <= ':') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy77;
				} else {
					if (yych == ']') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= '|') goto yy128;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy152:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy157;
	goto yy46;
yy153:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy90;
	goto yy46;
yy157:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy90;
	goto yy46;
yy160:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy160;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy162:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy163:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy163;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == '|') goto yy76;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy165:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy66;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy66;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy66;
					goto yy46;
				} else {
					if (yych <= '#') goto yy66;
					if (yych <= '\'') goto yy46;
					goto yy66;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy66;
				if (yych <= ':') goto yy46;
				goto yy66;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy66;
				} else {
					if (yych == ']') goto yy66;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy66;
				if (yych == 0x000000A0) goto yy66;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy66;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy66;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy66;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy66;
				if (yych <= 0x0000202E) goto yy46;
				goto yy66;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy66;
				} else {
					if (yych == 0x00003000) goto yy66;
					goto yy46;
				}
			}
		}
	}
yy166:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy177;
					if (yych <= 0x00000008) goto yy78;
					goto yy177;
				} else {
					if (yych == ' ') goto yy177;
					if (yych <= '!') goto yy78;
					goto yy177;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy177;
					goto yy78;
				} else {
					if (yych == ',') goto yy78;
					if (yych <= '.') goto yy177;
					goto yy78;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych == ':') goto yy78;
					goto yy177;
				} else {
					if (yych == '@') goto yy177;
					if (yych <= 'C') goto yy78;
					goto yy178;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy178;
					goto yy78;
				} else {
					if (yych <= 'S') goto yy178;
					if (yych == '[') goto yy177;
					goto yy78;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 's') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy177;
					if (yych <= 'c') goto yy78;
					goto yy178;
				} else {
					if (yych == 'l') goto yy178;
					if (yych <= 'r') goto yy78;
					goto yy178;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == '|') goto yy177;
					goto yy78;
				} else {
					if (yych <= 0x00000085) goto yy177;
					if (yych == 0x000000A0) goto yy177;
					goto yy78;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy177;
					if (yych <= 0x0000180D) goto yy78;
					goto yy177;
				} else {
					if (yych <= 0x00001FFF) goto yy78;
					if (yych <= 0x0000200A) goto yy177;
					if (yych <= 0x00002027) goto yy78;
					goto yy177;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy177;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy177;
					if (yych == 0x00003000) goto yy177;
					goto yy78;
				}
			}
		}
	}
yy167:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
yy168:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy166;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy170;
					if (yych <= '9') goto yy167;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy169;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy169;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy169;
					if (yych != 'l') goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy169;
					if (yych <= '{') goto yy46;
					goto yy76;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy169:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy173;
		goto yy46;
	} else {
		if (yych <= '-') goto yy173;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy174;
		goto yy46;
	}
yy170:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy171:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy171;
					if (yych <= ':') goto yy46;
					goto yy77;
				} else {
					if (yych == '@') goto yy79;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy173:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy174:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy174;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == '|') goto yy76;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy176:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy177:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy176;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy182;
					if (yych <= 'K') goto yy46;
					goto yy182;
				} else {
					if (yych == 'S') goto yy182;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'c') {
					if (yych == ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy182;
					if (yych == 'l') goto yy182;
					goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy182;
					if (yych <= '{') goto yy46;
					goto yy76;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy178:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy179;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy180;
		goto yy46;
	}
yy179:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy180:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy180;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == '|') goto yy76;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy182:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy183;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy184;
		goto yy46;
	}
yy183:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy184:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy184;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == '|') goto yy76;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy186:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy46;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy186;
					if (yych <= '#') goto yy66;
					goto yy186;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					goto yy186;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy186;
					goto yy304;
				} else {
					if (yych == ';') goto yy66;
					goto yy186;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy306;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					goto yy186;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy46;
					goto yy186;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00001680) goto yy304;
					if (yych <= 0x0000180D) goto yy186;
					goto yy304;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy186;
					if (yych <= 0x0000200A) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00002029) goto yy304;
					if (yych <= 0x0000202E) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00003000) goto yy304;
					if (yych <= 0x0000FFFF) goto yy186;
					goto yy46;
				}
			}
		}
	}
yy188:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy298;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy189:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 10) YYFILL(10);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy277;
					goto yy280;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy189;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= '@') goto yy199;
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy278;
					goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy278;
					if (yych == 'S') goto yy278;
					goto yy60;
				} else {
					if (yych <= '\\') {
						if (yych <= '[') goto yy197;
						goto yy65;
					} else {
						if (yych <= ']') goto yy197;
						if (yych <= '_') goto yy60;
						goto yy46;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy278;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych == 'l') goto yy278;
					if (yych <= 'r') goto yy60;
					goto yy278;
				}
			} else {
				if (yych <= '}') {
					if (yych <= 'z') goto yy60;
					if (yych == '|') goto yy279;
					goto yy46;
				} else {
					if (yych <= 0x0000007F) {
						if (yych <= '~') goto yy60;
						goto yy46;
					} else {
						if (yych == 0x00000085) goto yy198;
						goto yy60;
					}
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy191:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy197;
					goto yy61;
				} else {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy61;
					goto yy198;
				} else {
					if (yych == ';') goto yy197;
					goto yy61;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy197;
					goto yy61;
				} else {
					if (yych <= ']') goto yy197;
					if (yych <= 'm') goto yy61;
					goto yy274;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy198;
				if (yych <= 0x0000009F) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x0000180E) goto yy198;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy61;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy192:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy196;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy196:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych >= 0x00000001) goto yy61;
				} else {
					if (yych <= '\r') goto yy197;
					if (yych <= 0x0000001F) goto yy61;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy61;
				} else {
					if (yych <= '\'') goto yy61;
					if (yych >= '*') goto yy61;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy200;
					goto yy61;
				} else {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy61;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy197;
					if (yych <= '?') goto yy61;
					goto yy199;
				} else {
					if (yych != '[') goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych >= '^') goto yy61;
				} else {
					if (yych <= 'i') goto yy201;
					if (yych <= 0x00000084) goto yy61;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy61;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy61;
					if (yych <= 0x00002029) goto yy198;
					goto yy61;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy197:
	yych = *++YYCURSOR;
	goto yy78;
yy198:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ',') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy78;
			if (yych <= '\r') goto yy61;
			goto yy78;
		} else {
			if (yych == '\'') goto yy78;
			if (yych <= '+') goto yy61;
			goto yy78;
		}
	} else {
		if (yych <= '}') {
			if (yych == '`') goto yy78;
			if (yych <= 'z') goto yy61;
			goto yy78;
		} else {
			if (yych == 0x0000007F) goto yy78;
			if (yych <= 0x0000FFFF) goto yy61;
			goto yy78;
		}
	}
yy199:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy239;
		if (yych <= ',') goto yy61;
		goto yy239;
	} else {
		if (yych <= '.') goto yy238;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy240;
		goto yy61;
	}
yy200:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy202;
		if (yych <= '/') goto yy61;
		goto yy203;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy61;
			goto yy205;
		} else {
			if (yych == 'n') goto yy206;
			goto yy61;
		}
	}
yy201:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy197;
					goto yy61;
				} else {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy198;
				if (yych <= ':') goto yy61;
				goto yy197;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy61;
					goto yy197;
				} else {
					if (yych == ']') goto yy197;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy198;
				if (yych == 0x000000A0) goto yy198;
				goto yy61;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy61;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy61;
				if (yych <= 0x00002029) goto yy198;
				if (yych <= 0x0000202E) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy202:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy232;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy203:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy66;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ',') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				} else {
					if (yych <= '-') goto yy60;
					if (yych <= '.') goto yy214;
					if (yych <= '/') goto yy216;
					goto yy203;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych == ';') goto yy66;
					if (yych <= 'C') goto yy60;
					goto yy215;
				} else {
					if (yych == 'L') goto yy215;
					if (yych <= 'R') goto yy60;
					goto yy215;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
					goto yy215;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych == 'i') goto yy201;
					if (yych <= 'k') goto yy60;
					goto yy215;
				} else {
					if (yych == 's') goto yy215;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy205:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy197;
				if (yych <= 0x00000008) goto yy61;
				if (yych <= '\r') goto yy197;
				goto yy61;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy197;
					goto yy61;
				} else {
					if (yych <= '#') goto yy197;
					if (yych <= '\'') goto yy61;
					goto yy197;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy61;
					goto yy198;
				} else {
					if (yych == ';') goto yy197;
					goto yy61;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy197;
					goto yy61;
				} else {
					if (yych <= ']') goto yy197;
					if (yych <= 'm') goto yy61;
					goto yy211;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy198;
				if (yych <= 0x0000009F) goto yy61;
				goto yy198;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x0000180E) goto yy198;
					goto yy61;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy198;
					goto yy61;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy61;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy61;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					goto yy61;
				}
			}
		}
	}
yy206:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy210;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy210:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy201;
	goto yy61;
yy211:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy210;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy214:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy61;
				if (yych <= 0x00000008) goto yy64;
				if (yych <= '\r') goto yy61;
				goto yy64;
			} else {
				if (yych == '\'') goto yy64;
				if (yych <= '+') goto yy61;
				goto yy64;
			}
		} else {
			if (yych <= 'F') {
				if (yych <= '/') goto yy61;
				if (yych <= '9') goto yy222;
				if (yych <= 'C') goto yy61;
				goto yy224;
			} else {
				if (yych <= 'L') {
					if (yych <= 'K') goto yy61;
					goto yy224;
				} else {
					if (yych == 'S') goto yy224;
					goto yy61;
				}
			}
		}
	} else {
		if (yych <= 'r') {
			if (yych <= 'h') {
				if (yych <= '`') goto yy64;
				if (yych <= 'c') goto yy61;
				if (yych <= 'f') goto yy224;
				goto yy61;
			} else {
				if (yych <= 'i') goto yy201;
				if (yych == 'l') goto yy224;
				goto yy61;
			}
		} else {
			if (yych <= '|') {
				if (yych <= 's') goto yy224;
				if (yych <= 'z') goto yy61;
				if (yych <= '{') goto yy64;
				goto yy89;
			} else {
				if (yych <= '~') {
					if (yych <= '}') goto yy64;
					goto yy61;
				} else {
					if (yych <= 0x0000007F) goto yy64;
					if (yych <= 0x0000FFFF) goto yy61;
					goto yy64;
				}
			}
		}
	}
yy215:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy219;
		goto yy61;
	} else {
		if (yych <= '-') goto yy219;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy220;
		goto yy61;
	}
yy216:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy217:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'h') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy62;
					goto yy60;
				} else {
					if (yych <= '9') goto yy217;
					if (yych <= ':') goto yy60;
					goto yy66;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy66;
					goto yy65;
				} else {
					if (yych <= ']') goto yy66;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych <= 'i') goto yy201;
					if (yych <= 'z') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy219:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy220:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych == ',') goto yy46;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy220;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x0000007F) {
				if (yych <= '|') {
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy89;
				} else {
					if (yych == '~') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x000000A0) goto yy62;
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy222:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy66;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ',') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				} else {
					if (yych == '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy222;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych == ';') goto yy66;
					if (yych <= 'C') goto yy60;
					goto yy228;
				} else {
					if (yych == 'L') goto yy228;
					if (yych <= 'R') goto yy60;
					goto yy228;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
					goto yy228;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych == 'i') goto yy201;
					if (yych <= 'k') goto yy60;
					goto yy228;
				} else {
					if (yych == 's') goto yy228;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy224:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy225;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy226;
		goto yy61;
	}
yy225:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy226:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych == ',') goto yy46;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy226;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x0000007F) {
				if (yych <= '|') {
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy89;
				} else {
					if (yych == '~') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x000000A0) goto yy62;
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy228:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy229;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy230;
		goto yy61;
	}
yy229:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy230:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych == ',') goto yy46;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy230;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x0000007F) {
				if (yych <= '|') {
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy89;
				} else {
					if (yych == '~') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x000000A0) goto yy62;
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy232:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'f') {
		if (yych <= '9') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy66;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ',') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy66;
					if (yych <= '+') goto yy60;
					goto yy46;
				} else {
					if (yych == '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy232;
				}
			}
		} else {
			if (yych <= 'S') {
				if (yych <= 'F') {
					if (yych == ';') goto yy66;
					if (yych <= 'C') goto yy60;
				} else {
					if (yych == 'L') goto yy234;
					if (yych <= 'R') goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych <= 'Z') goto yy60;
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'c') goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych == 'i') goto yy201;
					if (yych <= 'k') goto yy60;
				} else {
					if (yych == 's') goto yy234;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy89;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy62;
					if (yych <= 0x0000009F) goto yy60;
					goto yy62;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy62;
					if (yych <= 0x0000180D) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy62;
					if (yych <= 0x00002027) goto yy60;
					goto yy62;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy234:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy235;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy236;
		goto yy61;
	}
yy235:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy236:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'i') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy66;
					if (yych <= 0x00000008) goto yy46;
					goto yy66;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy66;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy66;
					if (yych == ',') goto yy46;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '9') {
					if (yych <= '.') goto yy62;
					if (yych <= '/') goto yy60;
					goto yy236;
				} else {
					if (yych == ';') goto yy66;
					goto yy60;
				}
			} else {
				if (yych <= ']') {
					if (yych == '\\') goto yy65;
					goto yy66;
				} else {
					if (yych == '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x0000007F) {
				if (yych <= '|') {
					if (yych <= 'z') goto yy60;
					if (yych <= '{') goto yy46;
					goto yy89;
				} else {
					if (yych == '~') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy62;
					goto yy60;
				} else {
					if (yych <= 0x000000A0) goto yy62;
					if (yych == 0x00001680) goto yy62;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy62;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy62;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy62;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy62;
					if (yych <= 0x0000205E) goto yy60;
					goto yy62;
				} else {
					if (yych == 0x00003000) goto yy62;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy238:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '9') goto yy268;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy239:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy238;
		if (yych <= '/') goto yy61;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy61;
			goto yy261;
		} else {
			if (yych == 'n') goto yy260;
			goto yy61;
		}
	}
yy240:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy60;
					if (yych >= '/') goto yy244;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy240;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= 'F') goto yy243;
					if (yych == 'L') goto yy243;
					goto yy60;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy243;
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy243;
					if (yych <= 'k') goto yy60;
					goto yy243;
				} else {
					if (yych == 's') goto yy243;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy128;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy78;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy78;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy78;
					if (yych == '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy250;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= 'F') goto yy252;
					if (yych == 'L') goto yy252;
					goto yy60;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy252;
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy78;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy252;
					if (yych <= 'k') goto yy60;
					goto yy252;
				} else {
					if (yych == 's') goto yy252;
					if (yych <= 'z') goto yy60;
					goto yy78;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy128;
					if (yych == '~') goto yy60;
					goto yy78;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy78;
				}
			}
		}
	}
yy243:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy247;
		goto yy61;
	} else {
		if (yych <= '-') goto yy247;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy248;
		goto yy61;
	}
yy244:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy245:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy245;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= 'z') goto yy60;
					if (yych <= '}') goto yy46;
					goto yy60;
				} else {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002029) goto yy198;
					if (yych <= 0x0000202E) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy247:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy248:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy248;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy128;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy250:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy250;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= 'F') goto yy256;
					if (yych == 'L') goto yy256;
					goto yy60;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy256;
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy256;
					if (yych <= 'k') goto yy60;
					goto yy256;
				} else {
					if (yych == 's') goto yy256;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy128;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy252:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy253;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy254;
		goto yy61;
	}
yy253:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy254:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy254;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy128;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy256:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy257;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy258;
		goto yy61;
	}
yy257:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy258:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy258;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy128;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy260:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy265;
	goto yy61;
yy261:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy201;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy265:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy201;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy268:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'c') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych == '!') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '&') goto yy60;
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					goto yy60;
				} else {
					if (yych <= ',') goto yy46;
					if (yych == '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'R') {
				if (yych <= 'C') {
					if (yych <= '9') goto yy268;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= 'F') goto yy270;
					if (yych != 'L') goto yy60;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'S') goto yy270;
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= '{') {
				if (yych <= 'l') {
					if (yych <= 'f') goto yy270;
					if (yych <= 'k') goto yy60;
				} else {
					if (yych == 's') goto yy270;
					if (yych <= 'z') goto yy60;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000007F) {
					if (yych <= '|') goto yy128;
					if (yych == '~') goto yy60;
					goto yy46;
				} else {
					if (yych == 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych == 0x00001680) goto yy198;
					if (yych <= 0x0000180D) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					goto yy198;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych == 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy270:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy271;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy272;
		goto yy61;
	}
yy271:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy272:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '+') goto yy60;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych == '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy272;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= 'Z') goto yy60;
					if (yych <= '[') goto yy197;
					goto yy65;
				} else {
					if (yych <= ']') goto yy197;
					if (yych == '`') goto yy46;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= '}') {
					if (yych == '|') goto yy128;
					goto yy46;
				} else {
					if (yych == 0x0000007F) goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy198;
					if (yych <= 0x0000009F) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					goto yy198;
				} else {
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy274:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy61;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy61;
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') {
		if (yych <= 0x0000001F) {
			if (yych <= 0x00000000) goto yy61;
			if (yych <= 0x00000008) goto yy64;
			if (yych <= '\r') goto yy61;
			goto yy64;
		} else {
			if (yych <= '\'') {
				if (yych <= '&') goto yy61;
				goto yy64;
			} else {
				if (yych == ',') goto yy64;
				goto yy61;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych <= '0') goto yy196;
			if (yych == '`') goto yy64;
			goto yy61;
		} else {
			if (yych <= '~') {
				if (yych <= '}') goto yy64;
				goto yy61;
			} else {
				if (yych <= 0x0000007F) goto yy64;
				if (yych <= 0x0000FFFF) goto yy61;
				goto yy64;
			}
		}
	}
yy277:
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy78;
					if (yych <= '\r') goto yy197;
					goto yy78;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy78;
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy288;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= '@') goto yy199;
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy290;
					goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy290;
					if (yych == 'S') goto yy290;
					goto yy60;
				} else {
					if (yych <= '\\') {
						if (yych <= '[') goto yy197;
						goto yy65;
					} else {
						if (yych <= ']') goto yy197;
						if (yych <= '_') goto yy60;
						goto yy78;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy290;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych == 'l') goto yy290;
					if (yych <= 'r') goto yy60;
					goto yy290;
				}
			} else {
				if (yych <= '}') {
					if (yych <= 'z') goto yy60;
					if (yych == '|') goto yy279;
					goto yy78;
				} else {
					if (yych <= 0x0000007F) {
						if (yych <= '~') goto yy60;
						goto yy78;
					} else {
						if (yych == 0x00000085) goto yy198;
						goto yy60;
					}
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy78;
					}
				}
			}
		}
	}
yy278:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy285;
		goto yy61;
	} else {
		if (yych <= '-') goto yy285;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy286;
		goto yy61;
	}
yy279:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy283;
	goto yy46;
yy280:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy281:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '_') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy281;
					if (yych <= ':') goto yy60;
					goto yy197;
				}
			} else {
				if (yych <= 'Z') {
					if (yych == '@') goto yy199;
					goto yy60;
				} else {
					if (yych == '\\') goto yy65;
					if (yych <= ']') goto yy197;
					goto yy60;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'i') {
					if (yych <= '`') goto yy46;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych <= 'z') goto yy60;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy283:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy283;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy90;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy285:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy286:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '?') {
				if (yych <= '/') {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy286;
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych <= '@') goto yy199;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'z') {
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy288:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy288;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= '@') goto yy199;
					if (yych <= 'C') goto yy60;
					if (yych <= 'F') goto yy294;
					goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy294;
					if (yych == 'S') goto yy294;
					goto yy60;
				} else {
					if (yych <= '\\') {
						if (yych <= '[') goto yy197;
						goto yy65;
					} else {
						if (yych <= ']') goto yy197;
						if (yych <= '_') goto yy60;
						goto yy46;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy294;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych == 'l') goto yy294;
					if (yych <= 'r') goto yy60;
					goto yy294;
				}
			} else {
				if (yych <= '}') {
					if (yych <= 'z') goto yy60;
					if (yych == '|') goto yy279;
					goto yy46;
				} else {
					if (yych <= 0x0000007F) {
						if (yych <= '~') goto yy60;
						goto yy46;
					} else {
						if (yych == 0x00000085) goto yy198;
						goto yy60;
					}
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy290:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy291;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy292;
		goto yy61;
	}
yy291:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy292:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '?') {
				if (yych <= '/') {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy292;
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych <= '@') goto yy199;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'z') {
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy294:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy295;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy296;
		goto yy61;
	}
yy295:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy296:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '?') {
				if (yych <= '/') {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy296;
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych <= '@') goto yy199;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'z') {
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy298:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= '/') {
			if (yych <= '&') {
				if (yych <= 0x0000001F) {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					if (yych <= '\r') goto yy197;
					goto yy46;
				} else {
					if (yych == '!') goto yy60;
					if (yych <= '#') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '+') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					goto yy200;
				} else {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '?') {
					if (yych <= '9') goto yy298;
					if (yych == ';') goto yy197;
					goto yy60;
				} else {
					if (yych <= '@') goto yy199;
					if (yych <= 'C') goto yy60;
					if (yych >= 'G') goto yy60;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= 'L') goto yy300;
					if (yych != 'S') goto yy60;
				} else {
					if (yych <= '\\') {
						if (yych <= '[') goto yy197;
						goto yy65;
					} else {
						if (yych <= ']') goto yy197;
						if (yych <= '_') goto yy60;
						goto yy46;
					}
				}
			}
		}
	} else {
		if (yych <= 0x0000009F) {
			if (yych <= 's') {
				if (yych <= 'i') {
					if (yych <= 'c') goto yy60;
					if (yych <= 'f') goto yy300;
					if (yych <= 'h') goto yy60;
					goto yy201;
				} else {
					if (yych == 'l') goto yy300;
					if (yych <= 'r') goto yy60;
				}
			} else {
				if (yych <= '}') {
					if (yych <= 'z') goto yy60;
					if (yych == '|') goto yy279;
					goto yy46;
				} else {
					if (yych <= 0x0000007F) {
						if (yych <= '~') goto yy60;
						goto yy46;
					} else {
						if (yych == 0x00000085) goto yy198;
						goto yy60;
					}
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych <= 0x000000A0) goto yy198;
					if (yych == 0x00001680) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000180E) goto yy198;
					if (yych <= 0x00001FFF) goto yy60;
					if (yych <= 0x0000200A) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy198;
					if (yych == 0x0000202F) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x00002FFF) {
						if (yych <= 0x0000205F) goto yy198;
						goto yy60;
					} else {
						if (yych <= 0x00003000) goto yy198;
						if (yych <= 0x0000FFFF) goto yy60;
						goto yy46;
					}
				}
			}
		}
	}
yy300:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy61;
	} else {
		if (yych <= '-') goto yy301;
		if (yych <= '/') goto yy61;
		if (yych <= '9') goto yy302;
		goto yy61;
	}
yy301:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy61;
	if (yych >= ':') goto yy61;
yy302:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '`') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy197;
					if (yych <= 0x00000008) goto yy46;
					goto yy197;
				} else {
					if (yych <= 0x0000001F) goto yy46;
					if (yych <= ' ') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '#') goto yy197;
					if (yych <= '&') goto yy60;
					goto yy46;
				} else {
					if (yych <= ')') goto yy197;
					if (yych <= '*') goto yy60;
					if (yych <= '+') goto yy200;
					goto yy46;
				}
			}
		} else {
			if (yych <= '?') {
				if (yych <= '/') {
					if (yych <= '-') goto yy200;
					if (yych <= '.') goto yy198;
					goto yy60;
				} else {
					if (yych <= '9') goto yy302;
					if (yych == ';') goto yy197;
					goto yy60;
				}
			} else {
				if (yych <= '[') {
					if (yych <= '@') goto yy199;
					if (yych <= 'Z') goto yy60;
					goto yy197;
				} else {
					if (yych <= '\\') goto yy65;
					if (yych <= ']') goto yy197;
					if (yych <= '_') goto yy60;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= '~') {
				if (yych <= 'z') {
					if (yych == 'i') goto yy201;
					goto yy60;
				} else {
					if (yych == '|') goto yy279;
					if (yych <= '}') goto yy46;
					goto yy60;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 0x0000007F) goto yy46;
					if (yych <= 0x00000084) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x000000A0) goto yy198;
					if (yych <= 0x0000167F) goto yy60;
					goto yy198;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy198;
					goto yy60;
				} else {
					if (yych <= 0x0000200A) goto yy198;
					if (yych <= 0x00002027) goto yy60;
					if (yych <= 0x00002029) goto yy198;
					goto yy60;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy198;
					if (yych <= 0x0000205E) goto yy60;
					goto yy198;
				} else {
					if (yych == 0x00003000) goto yy198;
					if (yych <= 0x0000FFFF) goto yy60;
					goto yy46;
				}
			}
		}
	}
yy304:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'z') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy66;
					goto yy64;
				} else {
					if (yych <= '\r') goto yy66;
					if (yych <= 0x0000001F) goto yy64;
					goto yy66;
				}
			} else {
				if (yych <= '&') {
					if (yych <= '!') goto yy186;
					if (yych <= '#') goto yy66;
					goto yy186;
				} else {
					if (yych <= '\'') goto yy64;
					if (yych <= ')') goto yy66;
					goto yy186;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= ',') goto yy64;
					if (yych <= '-') goto yy186;
					goto yy304;
				} else {
					if (yych == ';') goto yy66;
					goto yy186;
				}
			} else {
				if (yych <= ']') {
					if (yych != '\\') goto yy66;
				} else {
					if (yych == '`') goto yy64;
					goto yy186;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '~') {
					if (yych <= '}') goto yy64;
					goto yy186;
				} else {
					if (yych <= 0x0000007F) goto yy64;
					if (yych <= 0x00000084) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00001680) goto yy304;
					if (yych <= 0x0000180D) goto yy186;
					goto yy304;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x00001FFF) goto yy186;
					if (yych <= 0x0000200A) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00002029) goto yy304;
					if (yych <= 0x0000202E) goto yy186;
					goto yy304;
				}
			} else {
				if (yych <= 0x00002FFF) {
					if (yych == 0x0000205F) goto yy304;
					goto yy186;
				} else {
					if (yych <= 0x00003000) goto yy304;
					if (yych <= 0x0000FFFF) goto yy186;
					goto yy64;
				}
			}
		}
	}
yy306:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych != 'x') goto yy46;
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy308;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy308:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ';') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy308;
		if (yych <= ':') goto yy46;
		goto yy186;
	} else {
		if (yych <= 'F') {
			if (yych <= '@') goto yy46;
			goto yy308;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy308;
			goto yy46;
		}
	}
yy310:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '/') goto yy64;
	if (yych <= '9') goto yy340;
	goto yy64;
yy311:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy77;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy77;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy77;
					goto yy46;
				} else {
					if (yych <= '#') goto yy77;
					if (yych <= '\'') goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy77;
				} else {
					if (yych == ';') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy77;
					goto yy46;
				} else {
					if (yych <= ']') goto yy77;
					if (yych <= 'm') goto yy46;
					goto yy337;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy77;
				if (yych <= 0x0000009F) goto yy46;
				goto yy77;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x0000180E) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy77;
					if (yych <= 0x0000202E) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy312:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy333;
	goto yy46;
yy313:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy317;
					if (yych <= '9') goto yy313;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy316;
					if (yych == 'L') goto yy316;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy316;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
					goto yy316;
				} else {
					if (yych == 'i') goto yy90;
					if (yych <= 'k') goto yy46;
					goto yy316;
				}
			} else {
				if (yych <= '|') {
					if (yych == 's') goto yy316;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy324;
					if (yych <= 0x00000008) goto yy78;
					goto yy324;
				} else {
					if (yych == ' ') goto yy324;
					if (yych <= '!') goto yy78;
					goto yy324;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy78;
					if (yych <= ')') goto yy324;
					goto yy78;
				} else {
					if (yych == ',') goto yy78;
					if (yych <= '.') goto yy324;
					goto yy78;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych == ':') goto yy78;
					goto yy324;
				} else {
					if (yych == '@') goto yy324;
					if (yych <= 'C') goto yy78;
					goto yy325;
				}
			} else {
				if (yych <= 'S') {
					if (yych == 'L') goto yy325;
					if (yych <= 'R') goto yy78;
					goto yy325;
				} else {
					if (yych == '[') goto yy324;
					if (yych <= '\\') goto yy78;
					goto yy324;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'r') {
				if (yych <= 'h') {
					if (yych <= 'c') goto yy78;
					if (yych <= 'f') goto yy325;
					goto yy78;
				} else {
					if (yych <= 'i') goto yy324;
					if (yych == 'l') goto yy325;
					goto yy78;
				}
			} else {
				if (yych <= '|') {
					if (yych <= 's') goto yy325;
					if (yych <= '{') goto yy78;
					goto yy324;
				} else {
					if (yych == 0x00000085) goto yy324;
					if (yych <= 0x0000009F) goto yy78;
					goto yy324;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy324;
					goto yy78;
				} else {
					if (yych <= 0x0000180E) goto yy324;
					if (yych <= 0x00001FFF) goto yy78;
					if (yych <= 0x0000200A) goto yy324;
					goto yy78;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy324;
					if (yych == 0x0000202F) goto yy324;
					goto yy78;
				} else {
					if (yych <= 0x0000205F) goto yy324;
					if (yych == 0x00003000) goto yy324;
					goto yy78;
				}
			}
		}
	}
yy316:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy320;
		goto yy46;
	} else {
		if (yych <= '-') goto yy320;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy321;
		goto yy46;
	}
yy317:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy318:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy80;
				} else {
					if (yych <= '.') goto yy77;
					if (yych <= '/') goto yy46;
					goto yy318;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy77;
					goto yy46;
				} else {
					if (yych <= '@') goto yy79;
					if (yych <= 'Z') goto yy46;
					goto yy77;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy77;
				} else {
					if (yych == 'i') goto yy90;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy320:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy321:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy321;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= ']') goto yy77;
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy323:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy324:
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy323;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy329;
					if (yych == 'L') goto yy329;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy329;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
					goto yy329;
				} else {
					if (yych == 'i') goto yy90;
					if (yych <= 'k') goto yy46;
					goto yy329;
				}
			} else {
				if (yych <= '|') {
					if (yych == 's') goto yy329;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy325:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy326;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy327;
		goto yy46;
	}
yy326:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy327:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy327;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= ']') goto yy77;
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy329:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy330;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy331;
		goto yy46;
	}
yy330:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy331:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy331;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= ']') goto yy77;
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy333:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy336:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy77;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy80;
					goto yy46;
				} else {
					if (yych <= '-') goto yy80;
					if (yych <= '.') goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy77;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy90;
					if (yych <= 0x00000084) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy77;
					if (yych <= 0x0000180D) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy337:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy336;
	goto yy46;
yy340:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy77;
					if (yych <= 0x00000008) goto yy46;
					goto yy77;
				} else {
					if (yych == ' ') goto yy77;
					if (yych <= '!') goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy77;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy340;
					goto yy46;
				} else {
					if (yych <= ';') goto yy77;
					if (yych == '@') goto yy79;
					goto yy46;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy342;
					if (yych != 'L') goto yy46;
				} else {
					if (yych <= 'S') goto yy342;
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy77;
					if (yych <= 'c') goto yy46;
				} else {
					if (yych == 'i') goto yy90;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= '|') {
					if (yych == 's') goto yy342;
					if (yych <= '{') goto yy46;
					goto yy279;
				} else {
					if (yych == 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy77;
					if (yych == 0x0000202F) goto yy77;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy77;
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy342:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy343;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy344;
		goto yy46;
	}
yy343:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy344:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy77;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy77;
					if (yych <= 0x0000001F) goto yy46;
					goto yy77;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy77;
					goto yy46;
				} else {
					if (yych <= ')') goto yy77;
					if (yych <= '*') goto yy46;
					goto yy80;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy80;
					goto yy77;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy344;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy77;
					if (yych <= '?') goto yy46;
					goto yy79;
				} else {
					if (yych == '[') goto yy77;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'i') {
					if (yych <= ']') goto yy77;
					if (yych <= 'h') goto yy46;
					goto yy90;
				} else {
					if (yych == '|') goto yy279;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy77;
					if (yych <= 0x0000009F) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00001680) goto yy77;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy77;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy77;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy77;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy77;
					if (yych <= 0x0000205E) goto yy46;
					goto yy77;
				} else {
					if (yych == 0x00003000) goto yy77;
					goto yy46;
				}
			}
		}
	}
yy346:
	++YYCURSOR;
#line 473 "src/scanner.re"
	{
            comment_count = 1;
            goto comment;
        }
#line 8882 "<stdout>"
yy348:
	++YYCURSOR;
#line 469 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return DATUM_COMMENT;
        }
#line 8890 "<stdout>"
yy350:
	yych = *++YYCURSOR;
	if (yych == 'u') goto yy788;
	goto yy46;
yy351:
	++YYCURSOR;
#line 453 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return VECTOR_START;
        }
#line 8902 "<stdout>"
yy353:
	yych = *++YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= ',') goto yy774;
		if (yych <= '9') goto yy776;
		if (yych <= '@') goto yy774;
		goto yy776;
	} else {
		if (yych <= '_') {
			if (yych <= '^') goto yy774;
			goto yy776;
		} else {
			if (yych <= '`') goto yy774;
			if (yych <= 'z') goto yy776;
			goto yy774;
		}
	}
yy354:
	yych = *++YYCURSOR;
	if (yych == '@') goto yy770;
	goto yy768;
yy355:
	yych = *++YYCURSOR;
	goto yy766;
yy356:
	yych = *++YYCURSOR;
	goto yy764;
yy357:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy759;
	if (yych == '\\') goto yy757;
	goto yy357;
yy359:
	yych = *++YYCURSOR;
	if (yych <= '.') {
		if (yych <= '*') {
			if (yych == '#') goto yy756;
			goto yy46;
		} else {
			if (yych == ',') goto yy46;
			if (yych <= '-') goto yy588;
			goto yy593;
		}
	} else {
		if (yych <= '@') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy589;
			goto yy46;
		} else {
			if (yych <= 'F') goto yy591;
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy591;
			goto yy46;
		}
	}
yy360:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy586;
	case '+':
	case '-':	goto yy527;
	case '.':	goto yy528;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy167;
	default:	goto yy46;
	}
yy361:
	yych = *++YYCURSOR;
	if (yych <= '+') {
		if (yych == '#') goto yy531;
		if (yych <= '*') goto yy46;
		goto yy532;
	} else {
		if (yych <= '-') {
			if (yych <= ',') goto yy46;
			goto yy532;
		} else {
			if (yych <= '/') goto yy46;
			if (yych <= '7') goto yy533;
			goto yy46;
		}
	}
yy362:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy526;
	case '+':
	case '-':	goto yy527;
	case '.':	goto yy528;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy167;
	default:	goto yy46;
	}
yy363:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy471;
	case '+':
	case '-':	goto yy472;
	case '0':
	case '1':	goto yy473;
	default:	goto yy46;
	}
yy364:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'a':	goto yy379;
	case 'b':	goto yy380;
	case 'd':	goto yy386;
	case 'e':	goto yy387;
	case 'l':	goto yy382;
	case 'n':	goto yy378;
	case 'p':	goto yy384;
	case 'r':	goto yy385;
	case 's':	goto yy377;
	case 't':	goto yy381;
	case 'v':	goto yy383;
	case 'x':	goto yy389;
	default:	goto yy388;
	}
yy365:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy375;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy375;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy375;
					goto yy46;
				} else {
					if (yych <= '#') goto yy375;
					if (yych <= '\'') goto yy46;
					goto yy375;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy375;
				if (yych <= ':') goto yy46;
				goto yy375;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy375;
				} else {
					if (yych == ']') goto yy375;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy375;
				if (yych == 0x000000A0) goto yy375;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy375;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy375;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy375;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy375;
				if (yych <= 0x0000202E) goto yy46;
				goto yy375;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy375;
				} else {
					if (yych == 0x00003000) goto yy375;
					goto yy46;
				}
			}
		}
	}
yy366:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= '/') {
		if (yych == '#') goto yy373;
		goto yy46;
	} else {
		if (yych <= '9') goto yy366;
		if (yych == '=') goto yy371;
		goto yy46;
	}
yy368:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy369;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy369;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy369;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy369;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy369;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy369;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy369:
	++YYCURSOR;
#line 246 "src/scanner.re"
	{
            yylval->boolValue = true;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 9184 "<stdout>"
yy371:
	++YYCURSOR;
#line 252 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINING_SHARED;
        }
#line 9194 "<stdout>"
yy373:
	++YYCURSOR;
#line 258 "src/scanner.re"
	{
            ucs4string n =  ucs4string(YYTOKEN + 1, (YYCURSOR - YYTOKEN - 1));
            yylval->intValue = atoi(n.ascii_c_str());
            YYTOKEN = YYCURSOR;
            return DEFINED_SHARED;
        }
#line 9204 "<stdout>"
yy375:
	++YYCURSOR;
#line 264 "src/scanner.re"
	{
            yylval->boolValue = false;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return SCHEME_BOOLEAN;
        }
#line 9214 "<stdout>"
yy377:
	yych = *++YYCURSOR;
	if (yych <= 'p') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'o') goto yy46;
					goto yy465;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy378:
	yych = *++YYCURSOR;
	if (yych <= 't') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy392;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy392;
					if (yych <= 0x0000001F) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy392;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= '[') {
				if (yych <= ':') {
					if (yych <= '.') goto yy392;
					goto yy46;
				} else {
					if (yych <= ';') goto yy392;
					if (yych <= 'Z') goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy392;
				} else {
					if (yych == 'e') goto yy454;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych <= 0x00000084) {
					if (yych <= 'u') goto yy453;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy392;
					if (yych <= 0x0000009F) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy379:
	yych = *++YYCURSOR;
	if (yych <= 'l') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'k') goto yy46;
					goto yy447;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy380:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= '`') goto yy46;
					goto yy437;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy381:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= '`') goto yy46;
					goto yy433;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy382:
	yych = *++YYCURSOR;
	if (yych <= 'i') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'h') goto yy46;
					goto yy424;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy383:
	yych = *++YYCURSOR;
	if (yych <= 't') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 's') goto yy46;
					goto yy419;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy384:
	yych = *++YYCURSOR;
	if (yych <= 'a') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= '`') goto yy46;
					goto yy414;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy385:
	yych = *++YYCURSOR;
	if (yych <= 'e') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'd') goto yy46;
					goto yy407;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy386:
	yych = *++YYCURSOR;
	if (yych <= 'e') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'd') goto yy46;
					goto yy400;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy387:
	yych = *++YYCURSOR;
	if (yych <= 's') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy392;
				} else {
					if (yych == ';') goto yy392;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy392;
					goto yy46;
				} else {
					if (yych <= ']') goto yy392;
					if (yych <= 'r') goto yy46;
					goto yy396;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy392;
				if (yych <= 0x0000009F) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x0000180E) goto yy392;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy392;
					if (yych <= 0x0000202E) goto yy46;
					goto yy392;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy388:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy392;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy46;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy392;
				if (yych <= ':') goto yy46;
				goto yy392;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy392;
				} else {
					if (yych == ']') goto yy392;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy392;
				if (yych == 0x000000A0) goto yy392;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy392;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy392;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy392;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy392;
				if (yych <= 0x0000202E) goto yy46;
				goto yy392;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy46;
				}
			}
		}
	}
yy389:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy392;
				if (yych <= 0x00000008) goto yy391;
				if (yych <= '\r') goto yy392;
				goto yy391;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy392;
					goto yy391;
				} else {
					if (yych <= '#') goto yy392;
					if (yych <= '\'') goto yy391;
					goto yy392;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy392;
				if (yych <= ':') goto yy391;
				goto yy392;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy391;
					goto yy392;
				} else {
					if (yych == ']') goto yy392;
					goto yy391;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy392;
				if (yych == 0x000000A0) goto yy392;
				goto yy391;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy392;
					goto yy391;
				} else {
					if (yych <= 0x0000180E) goto yy392;
					if (yych <= 0x00001FFF) goto yy391;
					goto yy392;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy391;
				if (yych <= 0x00002029) goto yy392;
				if (yych <= 0x0000202E) goto yy391;
				goto yy392;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy391;
					goto yy392;
				} else {
					if (yych == 0x00003000) goto yy392;
					goto yy391;
				}
			}
		}
	}
yy390:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy391:
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy394;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy394;
					if (yych <= 0x0000001F) goto yy46;
					goto yy394;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy394;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy394;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy394;
					goto yy46;
				} else {
					if (yych <= '9') goto yy390;
					if (yych <= ':') goto yy46;
					goto yy394;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy390;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy394;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy390;
				} else {
					if (yych == 0x00000085) goto yy394;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy394;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy394;
					if (yych <= 0x0000180D) goto yy46;
					goto yy394;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy394;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy394;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy394;
					if (yych <= 0x0000205E) goto yy46;
					goto yy394;
				} else {
					if (yych == 0x00003000) goto yy394;
					goto yy46;
				}
			}
		}
	}
yy392:
	++YYCURSOR;
#line 342 "src/scanner.re"
	{
            yylval->charValue = YYTOKEN[2];
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10281 "<stdout>"
yy394:
	++YYCURSOR;
#line 348 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->charValue = ScannerHelper::hexStringToUCS4Char(YYTOKEN + 3, YYCURSOR );
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10291 "<stdout>"
yy396:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy398;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy398;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy398;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy398;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy398;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy398;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy398:
	++YYCURSOR;
#line 336 "src/scanner.re"
	{
            yylval->charValue = 0x1B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10358 "<stdout>"
yy400:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy405;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy405;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy405;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy405;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy405;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy405;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy405:
	++YYCURSOR;
#line 330 "src/scanner.re"
	{
            yylval->charValue = 0x7F;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10431 "<stdout>"
yy407:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy412;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy412;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy412;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy412;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy412;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy412;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy412:
	++YYCURSOR;
#line 324 "src/scanner.re"
	{
            yylval->charValue = 0x0D;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10504 "<stdout>"
yy414:
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy417;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy417;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy417;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy417;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy417;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy417;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy417:
	++YYCURSOR;
#line 318 "src/scanner.re"
	{
            yylval->charValue = 0x0C;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10573 "<stdout>"
yy419:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy422;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy422;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy422;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy422;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy422;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy422;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy422:
	++YYCURSOR;
#line 312 "src/scanner.re"
	{
            yylval->charValue = 0x0B;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10642 "<stdout>"
yy424:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'd') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy431;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy431;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy431;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy431;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy431;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy431;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy431:
	++YYCURSOR;
#line 306 "src/scanner.re"
	{
            yylval->charValue = 0x0A;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10719 "<stdout>"
yy433:
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy435;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy435;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy435;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy435;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy435;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy435;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy435:
	++YYCURSOR;
#line 300 "src/scanner.re"
	{
            yylval->charValue = 0x09;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10786 "<stdout>"
yy437:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'k') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 's') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy445;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy445;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy445;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy445;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy445;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy445;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy445:
	++YYCURSOR;
#line 294 "src/scanner.re"
	{
            yylval->charValue = 0x08;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10865 "<stdout>"
yy447:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy451;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy451;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy451;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy451;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy451;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy451;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy451:
	++YYCURSOR;
#line 288 "src/scanner.re"
	{
            yylval->charValue = 0x07;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 10936 "<stdout>"
yy453:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy462;
	goto yy46;
yy454:
	yych = *++YYCURSOR;
	if (yych != 'w') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy460;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy460;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy460;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy460;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy460;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy460;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy460:
	++YYCURSOR;
#line 276 "src/scanner.re"
	{
            yylval->charValue = '\n';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 11015 "<stdout>"
yy462:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy463;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy463;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy463;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy463;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy463;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy463;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy463:
	++YYCURSOR;
#line 282 "src/scanner.re"
	{
            yylval->charValue = 0x00;
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 11080 "<stdout>"
yy465:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy46;
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy469;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy469;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy469;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy469;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy469;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy469;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy469:
	++YYCURSOR;
#line 270 "src/scanner.re"
	{
            yylval->charValue = ' ';
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return CHARACTER;
        }
#line 11151 "<stdout>"
yy471:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy525;
		if (yych <= 'H') goto yy46;
		goto yy525;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy525;
		} else {
			if (yych == 'i') goto yy525;
			goto yy46;
		}
	}
yy472:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy513;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy511;
		if (yych == 'n') goto yy512;
		goto yy46;
	}
yy473:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy478;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy478;
					if (yych <= 0x0000001F) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy478;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy476;
					goto yy46;
				} else {
					if (yych <= '-') goto yy476;
					if (yych <= '.') goto yy478;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '1') goto yy473;
					if (yych <= ':') goto yy46;
					goto yy478;
				} else {
					if (yych == '@') goto yy477;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy478;
					goto yy46;
				} else {
					if (yych <= ']') goto yy478;
					if (yych <= 0x00000084) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy478;
					if (yych <= 0x0000180D) goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy478;
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy509;
	goto yy46;
yy476:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy495;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy498;
		if (yych == 'n') goto yy497;
		goto yy46;
	}
yy477:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy480;
		goto yy46;
	} else {
		if (yych <= '-') goto yy480;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy481;
		goto yy46;
	}
yy478:
	++YYCURSOR;
#line 356 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 11301 "<stdout>"
yy480:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '2') goto yy46;
	} else {
		if (yych <= 'i') goto yy487;
		if (yych == 'n') goto yy486;
		goto yy46;
	}
yy481:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy478;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy478;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy478;
					goto yy46;
				} else {
					if (yych <= '#') goto yy478;
					if (yych <= '\'') goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy478;
				} else {
					if (yych <= '/') goto yy483;
					if (yych <= '1') goto yy481;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy478;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy478;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy478;
				if (yych <= 0x0000009F) goto yy46;
				goto yy478;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x0000180E) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy478;
					if (yych <= 0x0000202E) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy483:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy484:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy478;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy478;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy478;
					goto yy46;
				} else {
					if (yych <= '#') goto yy478;
					if (yych <= '\'') goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy478;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '1') goto yy484;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy478;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy478;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy478;
				if (yych <= 0x0000009F) goto yy46;
				goto yy478;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x0000180E) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy478;
					if (yych <= 0x0000202E) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy486:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy492;
	goto yy46;
yy487:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy491:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy478;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy478;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy478;
					goto yy46;
				} else {
					if (yych <= '#') goto yy478;
					if (yych <= '\'') goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy478;
				if (yych <= ':') goto yy46;
				goto yy478;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy478;
				} else {
					if (yych == ']') goto yy478;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy478;
				if (yych == 0x000000A0) goto yy478;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy478;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy478;
				if (yych <= 0x0000202E) goto yy46;
				goto yy478;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy492:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy491;
	goto yy46;
yy495:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '1') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy506;
		goto yy495;
	} else {
		if (yych == 'i') goto yy491;
		goto yy46;
	}
yy497:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy503;
	goto yy46;
yy498:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy478;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy478;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy478;
					goto yy46;
				} else {
					if (yych <= '#') goto yy478;
					if (yych <= '\'') goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy478;
				} else {
					if (yych == ';') goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy478;
					goto yy46;
				} else {
					if (yych <= ']') goto yy478;
					if (yych <= 'm') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy478;
				if (yych <= 0x0000009F) goto yy46;
				goto yy478;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x0000180E) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy478;
					if (yych <= 0x0000202E) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy502:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy491;
	goto yy46;
yy503:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy502;
	goto yy46;
yy506:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy507:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '1') goto yy507;
	if (yych == 'i') goto yy491;
	goto yy46;
yy509:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy478;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy478;
					if (yych <= 0x0000001F) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy478;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy476;
					goto yy46;
				} else {
					if (yych <= '-') goto yy476;
					if (yych <= '.') goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '1') goto yy509;
					if (yych <= ':') goto yy46;
					goto yy478;
				} else {
					if (yych == '@') goto yy477;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy478;
					goto yy46;
				} else {
					if (yych <= ']') goto yy478;
					if (yych <= 0x00000084) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy478;
					if (yych <= 0x0000180D) goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy478;
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy511:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy478;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy478;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy478;
					goto yy46;
				} else {
					if (yych <= '#') goto yy478;
					if (yych <= '\'') goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy478;
				} else {
					if (yych == ';') goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy478;
					goto yy46;
				} else {
					if (yych <= ']') goto yy478;
					if (yych <= 'm') goto yy46;
					goto yy522;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy478;
				if (yych <= 0x0000009F) goto yy46;
				goto yy478;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x0000180E) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy478;
					if (yych <= 0x0000202E) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy512:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy518;
	goto yy46;
yy513:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy478;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy478;
					if (yych <= 0x0000001F) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy478;
					goto yy46;
				} else {
					if (yych <= ')') goto yy478;
					if (yych <= '*') goto yy46;
					goto yy476;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy476;
				} else {
					if (yych <= '.') goto yy478;
					if (yych >= '0') goto yy513;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy478;
					goto yy46;
				} else {
					if (yych <= '@') goto yy477;
					if (yych <= 'Z') goto yy46;
					goto yy478;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy478;
				} else {
					if (yych == 'i') goto yy491;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy478;
					if (yych <= 0x0000009F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00001680) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy478;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy478;
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '2') goto yy46;
yy516:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy478;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy478;
					if (yych <= 0x0000001F) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy478;
					goto yy46;
				} else {
					if (yych <= ')') goto yy478;
					if (yych <= '*') goto yy46;
					goto yy476;
				}
			}
		} else {
			if (yych <= '1') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy476;
				} else {
					if (yych <= '.') goto yy478;
					if (yych <= '/') goto yy46;
					goto yy516;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy478;
					goto yy46;
				} else {
					if (yych <= '@') goto yy477;
					if (yych <= 'Z') goto yy46;
					goto yy478;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy478;
				} else {
					if (yych == 'i') goto yy491;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy478;
					if (yych <= 0x0000009F) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00001680) goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy478;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy478;
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy518:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy521:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy478;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy478;
					if (yych <= 0x0000001F) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy478;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy478;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy476;
					goto yy46;
				} else {
					if (yych <= '-') goto yy476;
					if (yych <= '.') goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy478;
					if (yych <= '?') goto yy46;
					goto yy477;
				} else {
					if (yych == '[') goto yy478;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy478;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy491;
					if (yych <= 0x00000084) goto yy46;
					goto yy478;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy478;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy478;
					if (yych <= 0x0000180D) goto yy46;
					goto yy478;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy478;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy478;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy478;
					if (yych <= 0x0000205E) goto yy46;
					goto yy478;
				} else {
					if (yych == 0x00003000) goto yy478;
					goto yy46;
				}
			}
		}
	}
yy522:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy521;
	goto yy46;
yy525:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy472;
		goto yy46;
	} else {
		if (yych <= '-') goto yy472;
		if (yych <= '/') goto yy46;
		if (yych <= '1') goto yy473;
		goto yy46;
	}
yy526:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy530;
		if (yych <= 'H') goto yy46;
		goto yy530;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy530;
		} else {
			if (yych == 'i') goto yy530;
			goto yy46;
		}
	}
yy527:
	yych = *++YYCURSOR;
	if (yych <= '9') {
		if (yych == '.') goto yy529;
		if (yych <= '/') goto yy46;
		goto yy313;
	} else {
		if (yych <= 'i') {
			if (yych <= 'h') goto yy46;
			goto yy311;
		} else {
			if (yych == 'n') goto yy312;
			goto yy46;
		}
	}
yy528:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy73;
	goto yy46;
yy529:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy340;
	goto yy46;
yy530:
	yych = *++YYCURSOR;
	if (yych <= '-') {
		if (yych == '+') goto yy527;
		if (yych <= ',') goto yy46;
		goto yy527;
	} else {
		if (yych <= '.') goto yy528;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy167;
		goto yy46;
	}
yy531:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy585;
		if (yych <= 'H') goto yy46;
		goto yy585;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy585;
		} else {
			if (yych == 'i') goto yy585;
			goto yy46;
		}
	}
yy532:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy573;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy571;
		if (yych == 'n') goto yy572;
		goto yy46;
	}
yy533:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy538;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy538;
					if (yych <= 0x0000001F) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy538;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy536;
					goto yy46;
				} else {
					if (yych <= '-') goto yy536;
					if (yych <= '.') goto yy538;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '7') goto yy533;
					if (yych <= ':') goto yy46;
					goto yy538;
				} else {
					if (yych == '@') goto yy537;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy538;
					goto yy46;
				} else {
					if (yych <= ']') goto yy538;
					if (yych <= 0x00000084) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy538;
					if (yych <= 0x0000180D) goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy538;
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy569;
	goto yy46;
yy536:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy555;
		goto yy46;
	} else {
		if (yych <= 'i') goto yy558;
		if (yych == 'n') goto yy557;
		goto yy46;
	}
yy537:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy540;
		goto yy46;
	} else {
		if (yych <= '-') goto yy540;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy541;
		goto yy46;
	}
yy538:
	++YYCURSOR;
#line 368 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 12342 "<stdout>"
yy540:
	yych = *++YYCURSOR;
	if (yych <= 'h') {
		if (yych <= '/') goto yy46;
		if (yych >= '8') goto yy46;
	} else {
		if (yych <= 'i') goto yy547;
		if (yych == 'n') goto yy546;
		goto yy46;
	}
yy541:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy538;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy538;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy538;
					goto yy46;
				} else {
					if (yych <= '#') goto yy538;
					if (yych <= '\'') goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy538;
				} else {
					if (yych <= '/') goto yy543;
					if (yych <= '7') goto yy541;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy538;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy538;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy538;
				if (yych <= 0x0000009F) goto yy46;
				goto yy538;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x0000180E) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy538;
					if (yych <= 0x0000202E) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy543:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy544:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy538;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy538;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy538;
					goto yy46;
				} else {
					if (yych <= '#') goto yy538;
					if (yych <= '\'') goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy538;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '7') goto yy544;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy538;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy538;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy538;
				if (yych <= 0x0000009F) goto yy46;
				goto yy538;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x0000180E) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy538;
					if (yych <= 0x0000202E) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy546:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy552;
	goto yy46;
yy547:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy551:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy538;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy538;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy538;
					goto yy46;
				} else {
					if (yych <= '#') goto yy538;
					if (yych <= '\'') goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy538;
				if (yych <= ':') goto yy46;
				goto yy538;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy538;
				} else {
					if (yych == ']') goto yy538;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy538;
				if (yych == 0x000000A0) goto yy538;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy538;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy538;
				if (yych <= 0x0000202E) goto yy46;
				goto yy538;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy552:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy551;
	goto yy46;
yy555:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '7') {
		if (yych <= '.') goto yy46;
		if (yych <= '/') goto yy566;
		goto yy555;
	} else {
		if (yych == 'i') goto yy551;
		goto yy46;
	}
yy557:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy563;
	goto yy46;
yy558:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy538;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy538;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy538;
					goto yy46;
				} else {
					if (yych <= '#') goto yy538;
					if (yych <= '\'') goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy538;
				} else {
					if (yych == ';') goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy538;
					goto yy46;
				} else {
					if (yych <= ']') goto yy538;
					if (yych <= 'm') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy538;
				if (yych <= 0x0000009F) goto yy46;
				goto yy538;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x0000180E) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy538;
					if (yych <= 0x0000202E) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy562:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy551;
	goto yy46;
yy563:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy562;
	goto yy46;
yy566:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy567:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '7') goto yy567;
	if (yych == 'i') goto yy551;
	goto yy46;
yy569:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy538;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy538;
					if (yych <= 0x0000001F) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy538;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy536;
					goto yy46;
				} else {
					if (yych <= '-') goto yy536;
					if (yych <= '.') goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '7') goto yy569;
					if (yych <= ':') goto yy46;
					goto yy538;
				} else {
					if (yych == '@') goto yy537;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy538;
					goto yy46;
				} else {
					if (yych <= ']') goto yy538;
					if (yych <= 0x00000084) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy538;
					if (yych <= 0x0000180D) goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy538;
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy571:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy538;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy538;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy538;
					goto yy46;
				} else {
					if (yych <= '#') goto yy538;
					if (yych <= '\'') goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy538;
				} else {
					if (yych == ';') goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy538;
					goto yy46;
				} else {
					if (yych <= ']') goto yy538;
					if (yych <= 'm') goto yy46;
					goto yy582;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy538;
				if (yych <= 0x0000009F) goto yy46;
				goto yy538;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x0000180E) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy538;
					if (yych <= 0x0000202E) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy572:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy578;
	goto yy46;
yy573:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy538;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy538;
					if (yych <= 0x0000001F) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy538;
					goto yy46;
				} else {
					if (yych <= ')') goto yy538;
					if (yych <= '*') goto yy46;
					goto yy536;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy536;
				} else {
					if (yych <= '.') goto yy538;
					if (yych >= '0') goto yy573;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy538;
					goto yy46;
				} else {
					if (yych <= '@') goto yy537;
					if (yych <= 'Z') goto yy46;
					goto yy538;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy538;
				} else {
					if (yych == 'i') goto yy551;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy538;
					if (yych <= 0x0000009F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00001680) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy538;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy538;
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= '8') goto yy46;
yy576:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy538;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy538;
					if (yych <= 0x0000001F) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy538;
					goto yy46;
				} else {
					if (yych <= ')') goto yy538;
					if (yych <= '*') goto yy46;
					goto yy536;
				}
			}
		} else {
			if (yych <= '7') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy536;
				} else {
					if (yych <= '.') goto yy538;
					if (yych <= '/') goto yy46;
					goto yy576;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy538;
					goto yy46;
				} else {
					if (yych <= '@') goto yy537;
					if (yych <= 'Z') goto yy46;
					goto yy538;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy538;
				} else {
					if (yych == 'i') goto yy551;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy538;
					if (yych <= 0x0000009F) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00001680) goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy538;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy538;
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy578:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy581:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy538;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy538;
					if (yych <= 0x0000001F) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy538;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy538;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy536;
					goto yy46;
				} else {
					if (yych <= '-') goto yy536;
					if (yych <= '.') goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy538;
					if (yych <= '?') goto yy46;
					goto yy537;
				} else {
					if (yych == '[') goto yy538;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy538;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy551;
					if (yych <= 0x00000084) goto yy46;
					goto yy538;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy538;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy538;
					if (yych <= 0x0000180D) goto yy46;
					goto yy538;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy538;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy538;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy538;
					if (yych <= 0x0000205E) goto yy46;
					goto yy538;
				} else {
					if (yych == 0x00003000) goto yy538;
					goto yy46;
				}
			}
		}
	}
yy582:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy581;
	goto yy46;
yy585:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy532;
		goto yy46;
	} else {
		if (yych <= '-') goto yy532;
		if (yych <= '/') goto yy46;
		if (yych <= '7') goto yy533;
		goto yy46;
	}
yy586:
	yych = *++YYCURSOR;
	if (yych <= 'X') {
		if (yych <= 'D') {
			if (yych == 'B') goto yy525;
			if (yych <= 'C') goto yy46;
			goto yy530;
		} else {
			if (yych == 'O') goto yy585;
			if (yych <= 'W') goto yy46;
		}
	} else {
		if (yych <= 'd') {
			if (yych == 'b') goto yy525;
			if (yych <= 'c') goto yy46;
			goto yy530;
		} else {
			if (yych <= 'o') {
				if (yych <= 'n') goto yy46;
				goto yy585;
			} else {
				if (yych != 'x') goto yy46;
			}
		}
	}
yy587:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych != '+') goto yy46;
		} else {
			if (yych <= '-') goto yy588;
			if (yych <= '.') goto yy593;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy589;
			if (yych <= '@') goto yy46;
			goto yy591;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy591;
			goto yy46;
		}
	}
yy588:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy718;
			goto yy46;
		} else {
			if (yych <= '9') goto yy714;
			if (yych <= '@') goto yy46;
			goto yy716;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy716;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy712;
			if (yych == 'n') goto yy713;
			goto yy46;
		}
	}
yy589:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy690;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy687;
					if (yych <= '9') goto yy589;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy691;
					if (yych <= 'K') goto yy46;
					goto yy692;
				} else {
					if (yych == 'S') goto yy692;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= '`') {
					if (yych == ']') goto yy597;
					goto yy46;
				} else {
					if (yych <= 'c') goto yy591;
					if (yych <= 'f') goto yy691;
					if (yych <= 'k') goto yy46;
					goto yy692;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy692;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy597;
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy591:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy597;
				} else {
					if (yych <= '/') goto yy687;
					if (yych <= '9') goto yy591;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				} else {
					if (yych <= 'F') goto yy591;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy591;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy593:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy594:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '+') goto yy600;
					if (yych <= ',') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy594;
				} else {
					if (yych == ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				} else {
					if (yych <= 'L') goto yy596;
					if (yych != 'S') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy597;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy596;
					if (yych <= 'k') goto yy46;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych != 's') goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy597;
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy596:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy684;
		goto yy46;
	} else {
		if (yych <= '-') goto yy684;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy685;
		goto yy46;
	}
yy597:
	++YYCURSOR;
yy598:
#line 374 "src/scanner.re"
	{
           YYCURSOR--;
           yylval->stringValue =  ucs4string(YYTOKEN, (YYCURSOR - YYTOKEN));
           YYTOKEN = YYCURSOR;
           return NUMBER;
       }
#line 13555 "<stdout>"
yy599:
	yych = *++YYCURSOR;
	if (yych <= '/') {
		if (yych <= ',') {
			if (yych == '+') goto yy643;
			goto yy46;
		} else {
			if (yych <= '-') goto yy643;
			if (yych <= '.') goto yy648;
			goto yy46;
		}
	} else {
		if (yych <= 'F') {
			if (yych <= '9') goto yy644;
			if (yych <= '@') goto yy46;
			goto yy646;
		} else {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy646;
			goto yy46;
		}
	}
yy600:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy607;
			goto yy46;
		} else {
			if (yych <= '9') goto yy603;
			if (yych <= '@') goto yy46;
			goto yy605;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy605;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy601;
			if (yych == 'n') goto yy602;
			goto yy46;
		}
	}
yy601:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych == ';') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 'm') goto yy46;
					goto yy640;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy602:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy636;
	goto yy46;
yy603:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= 'R') {
		if (yych <= '@') {
			if (yych <= '.') {
				if (yych <= '-') goto yy46;
				goto yy618;
			} else {
				if (yych <= '/') goto yy615;
				if (yych <= '9') goto yy603;
				goto yy46;
			}
		} else {
			if (yych <= 'F') {
				if (yych >= 'D') goto yy619;
			} else {
				if (yych == 'L') goto yy620;
				goto yy46;
			}
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') {
				if (yych <= 'S') goto yy620;
				goto yy46;
			} else {
				if (yych <= 'c') goto yy605;
				if (yych <= 'f') goto yy619;
				goto yy46;
			}
		} else {
			if (yych <= 'l') {
				if (yych <= 'i') goto yy611;
				if (yych <= 'k') goto yy46;
				goto yy620;
			} else {
				if (yych == 's') goto yy620;
				goto yy46;
			}
		}
	}
yy605:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy615;
		} else {
			if (yych <= '9') goto yy605;
			if (yych <= '@') goto yy46;
			goto yy605;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy605;
		} else {
			if (yych == 'i') goto yy611;
			goto yy46;
		}
	}
yy607:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy608:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy608;
			if (yych <= 'C') goto yy46;
		} else {
			if (yych == 'L') goto yy610;
			if (yych <= 'R') goto yy46;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy610;
			if (yych <= 'h') goto yy46;
			goto yy611;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
			} else {
				if (yych != 's') goto yy46;
			}
		}
	}
yy610:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy612;
		goto yy46;
	} else {
		if (yych <= '-') goto yy612;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy613;
		goto yy46;
	}
yy611:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy597;
				if (yych <= ':') goto yy46;
				goto yy597;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
					goto yy597;
				} else {
					if (yych == ']') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy597;
				if (yych == 0x000000A0) goto yy597;
				goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy597;
				if (yych <= 0x0000202E) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy612:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy613:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy613;
	if (yych == 'i') goto yy611;
	goto yy46;
yy615:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy46;
	goto yy617;
yy616:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy617:
	if (yych <= 'F') {
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy616;
		if (yych <= '@') goto yy46;
		goto yy616;
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy616;
		} else {
			if (yych == 'i') goto yy611;
			goto yy46;
		}
	}
yy618:
	yych = *++YYCURSOR;
	if (yych <= 'S') {
		if (yych <= 'K') {
			if (yych <= 'C') goto yy627;
			if (yych <= 'F') goto yy628;
			goto yy627;
		} else {
			if (yych <= 'L') goto yy628;
			if (yych <= 'R') goto yy627;
			goto yy628;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'c') goto yy627;
			if (yych <= 'f') goto yy628;
			goto yy627;
		} else {
			if (yych <= 'l') goto yy628;
			if (yych == 's') goto yy628;
			goto yy627;
		}
	}
yy619:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy621;
	if (yych == '-') goto yy621;
	goto yy625;
yy620:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy621;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy622;
		goto yy46;
	}
yy621:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy622:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy622;
	if (yych == 'i') goto yy611;
	goto yy46;
yy624:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy625:
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych <= '.') goto yy46;
			goto yy615;
		} else {
			if (yych <= '9') goto yy624;
			if (yych <= '@') goto yy46;
			goto yy605;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= '`') goto yy46;
			goto yy605;
		} else {
			if (yych == 'i') goto yy611;
			goto yy46;
		}
	}
yy626:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy627:
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy46;
			if (yych <= '9') goto yy626;
			if (yych <= 'C') goto yy46;
			goto yy632;
		} else {
			if (yych == 'L') goto yy632;
			if (yych <= 'R') goto yy46;
			goto yy632;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy46;
			if (yych <= 'f') goto yy632;
			if (yych <= 'h') goto yy46;
			goto yy611;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy46;
				goto yy632;
			} else {
				if (yych == 's') goto yy632;
				goto yy46;
			}
		}
	}
yy628:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy629;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy630;
		goto yy46;
	}
yy629:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy630:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy630;
	if (yych == 'i') goto yy611;
	goto yy46;
yy632:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy633;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy634;
		goto yy46;
	}
yy633:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy634:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych <= '9') goto yy634;
	if (yych == 'i') goto yy611;
	goto yy46;
yy636:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy639:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy611;
	goto yy46;
yy640:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy639;
	goto yy46;
yy643:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy648;
			goto yy46;
		} else {
			if (yych <= '9') goto yy644;
			if (yych <= '@') goto yy46;
			goto yy646;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy646;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy677;
			if (yych == 'n') goto yy676;
			goto yy46;
		}
	}
yy644:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '9') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych <= '-') goto yy46;
					if (yych <= '.') goto yy658;
					if (yych <= '/') goto yy655;
					goto yy644;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= '@') {
					if (yych == ';') goto yy597;
					goto yy46;
				} else {
					if (yych <= 'C') goto yy646;
					if (yych <= 'F') goto yy659;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy660;
					if (yych <= 'R') goto yy46;
					goto yy660;
				} else {
					if (yych == '[') goto yy597;
					if (yych <= '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 'r') {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					if (yych >= 'd') goto yy659;
				} else {
					if (yych == 'l') goto yy660;
					goto yy46;
				}
			} else {
				if (yych <= 0x00000085) {
					if (yych <= 's') goto yy660;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x000000A0) goto yy597;
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy646:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy597;
					goto yy655;
				} else {
					if (yych <= '9') goto yy646;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy646;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy646;
				} else {
					if (yych == 0x00000085) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy648:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy649:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '.') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy649;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych >= 'G') goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy651;
					if (yych <= 'R') goto yy46;
				} else {
					if (yych == '[') goto yy597;
					if (yych <= '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych >= 'g') goto yy46;
				} else {
					if (yych <= 'l') goto yy651;
					if (yych <= 'r') goto yy46;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy597;
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy651:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy652;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy653;
		goto yy46;
	}
yy652:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy653:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy653;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy597;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy655:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy656;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy656:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy597;
					goto yy46;
				} else {
					if (yych <= '9') goto yy656;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy656;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy656;
				} else {
					if (yych == 0x00000085) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy658:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy598;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy598;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy598;
					goto yy597;
				} else {
					if (yych == '.') goto yy597;
					goto yy598;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy666;
					if (yych <= ':') goto yy598;
					goto yy597;
				} else {
					if (yych <= 'C') goto yy598;
					if (yych <= 'F') goto yy668;
					goto yy598;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy668;
					if (yych <= 'R') goto yy598;
					goto yy668;
				} else {
					if (yych == '[') goto yy597;
					if (yych <= '\\') goto yy598;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy598;
					if (yych <= 'f') goto yy668;
					goto yy598;
				} else {
					if (yych <= 'l') goto yy668;
					if (yych <= 'r') goto yy598;
					goto yy668;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy597;
					goto yy598;
				} else {
					if (yych <= 0x000000A0) goto yy597;
					if (yych <= 0x0000167F) goto yy598;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy597;
					goto yy598;
				} else {
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy598;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy598;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy598;
				}
			}
		}
	}
yy659:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy661;
	if (yych == '-') goto yy661;
	goto yy665;
yy660:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy661;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy662;
		goto yy46;
	}
yy661:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy662:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy662;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy597;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy664:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy665:
	if (yych <= ']') {
		if (yych <= '-') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '.') goto yy597;
					goto yy655;
				} else {
					if (yych <= '9') goto yy664;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= '@') goto yy46;
					if (yych <= 'F') goto yy646;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x0000009F) {
				if (yych <= 'f') {
					if (yych <= '`') goto yy46;
					goto yy646;
				} else {
					if (yych == 0x00000085) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych <= 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy666:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '/') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '.') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 'K') {
				if (yych <= ';') {
					if (yych <= '9') goto yy666;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy672;
					goto yy46;
				}
			} else {
				if (yych <= 'S') {
					if (yych <= 'L') goto yy672;
					if (yych <= 'R') goto yy46;
					goto yy672;
				} else {
					if (yych == '[') goto yy597;
					if (yych <= '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001680) {
			if (yych <= 's') {
				if (yych <= 'k') {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy672;
					goto yy46;
				} else {
					if (yych <= 'l') goto yy672;
					if (yych <= 'r') goto yy46;
					goto yy672;
				}
			} else {
				if (yych <= 0x0000009F) {
					if (yych == 0x00000085) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x000000A0) goto yy597;
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x00001FFF) {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy668:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy669;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy670;
		goto yy46;
	}
yy669:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy670:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy670;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy597;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy672:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy673;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy674;
		goto yy46;
	}
yy673:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy674:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy674;
					goto yy46;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy597;
					goto yy46;
				} else {
					if (yych == '\\') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy676:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy681;
	goto yy46;
yy677:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy611;
	goto yy46;
yy681:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy611;
	goto yy46;
yy684:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy685:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy600;
					goto yy46;
				} else {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy685;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych == '@') goto yy599;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy687:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy688;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy688:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy597;
				} else {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy688;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				} else {
					if (yych <= 'F') goto yy688;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy688;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy690:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy703;
					if (yych <= 0x00000008) goto yy598;
					goto yy703;
				} else {
					if (yych == ' ') goto yy703;
					goto yy598;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy703;
					if (yych <= '\'') goto yy598;
					goto yy703;
				} else {
					if (yych == '+') goto yy703;
					if (yych <= ',') goto yy598;
					goto yy703;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy598;
					if (yych <= '9') goto yy703;
					goto yy598;
				} else {
					if (yych <= ';') goto yy703;
					if (yych == '@') goto yy703;
					goto yy598;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy704;
					if (yych <= 'K') goto yy598;
					goto yy704;
				} else {
					if (yych == 'S') goto yy704;
					if (yych <= 'Z') goto yy598;
					goto yy703;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'c') {
					if (yych == ']') goto yy703;
					goto yy598;
				} else {
					if (yych <= 'f') goto yy704;
					if (yych <= 'k') goto yy598;
					goto yy704;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy704;
					goto yy598;
				} else {
					if (yych <= 0x00000085) goto yy703;
					if (yych == 0x000000A0) goto yy703;
					goto yy598;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy703;
					if (yych <= 0x0000180D) goto yy598;
					goto yy703;
				} else {
					if (yych <= 0x00001FFF) goto yy598;
					if (yych <= 0x0000200A) goto yy703;
					if (yych <= 0x00002027) goto yy598;
					goto yy703;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy703;
					goto yy598;
				} else {
					if (yych <= 0x0000205F) goto yy703;
					if (yych == 0x00003000) goto yy703;
					goto yy598;
				}
			}
		}
	}
yy691:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy698;
	if (yych == '-') goto yy698;
	goto yy697;
yy692:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy693;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy694;
		goto yy46;
	}
yy693:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy694:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy600;
					goto yy46;
				} else {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy694;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych == '@') goto yy599;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy696:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy697:
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '.') {
					if (yych <= ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy597;
				} else {
					if (yych <= '/') goto yy687;
					if (yych <= '9') goto yy696;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				} else {
					if (yych <= 'F') goto yy591;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych <= '`') goto yy46;
					if (yych <= 'f') goto yy591;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy698:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy607;
			goto yy46;
		} else {
			if (yych <= '9') goto yy699;
			if (yych <= '@') goto yy46;
			goto yy605;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy605;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy601;
			if (yych == 'n') goto yy602;
			goto yy46;
		}
	}
yy699:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy615;
					if (yych <= '9') goto yy699;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
					goto yy605;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy619;
					if (yych == 'L') goto yy620;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy620;
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
					goto yy605;
				} else {
					if (yych <= 'f') goto yy619;
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy620;
					if (yych <= 'r') goto yy46;
					goto yy620;
				} else {
					if (yych == 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy597;
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy701:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 'S') {
		if (yych <= 'F') {
			if (yych <= '/') goto yy598;
			if (yych <= '9') goto yy626;
			if (yych <= 'C') goto yy598;
			goto yy628;
		} else {
			if (yych == 'L') goto yy628;
			if (yych <= 'R') goto yy598;
			goto yy628;
		}
	} else {
		if (yych <= 'i') {
			if (yych <= 'c') goto yy598;
			if (yych <= 'f') goto yy628;
			if (yych <= 'h') goto yy598;
			goto yy611;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy598;
				goto yy628;
			} else {
				if (yych == 's') goto yy628;
				goto yy598;
			}
		}
	}
yy702:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy703:
	if (yych <= 'Z') {
		if (yych <= '-') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '+') goto yy600;
					if (yych <= ',') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '@') {
				if (yych <= '9') {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy702;
				} else {
					if (yych == ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				}
			} else {
				if (yych <= 'K') {
					if (yych <= 'C') goto yy46;
					if (yych <= 'F') goto yy708;
					goto yy46;
				} else {
					if (yych <= 'L') goto yy708;
					if (yych == 'S') goto yy708;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= ']') {
					if (yych == '\\') goto yy46;
					goto yy597;
				} else {
					if (yych <= 'c') goto yy46;
					if (yych <= 'f') goto yy708;
					if (yych <= 'k') goto yy46;
					goto yy708;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy708;
					goto yy46;
				} else {
					if (yych <= 0x00000085) goto yy597;
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					if (yych <= 0x00002027) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy704:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy705;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy706;
		goto yy46;
	}
yy705:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy706:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy600;
					goto yy46;
				} else {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy706;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych == '@') goto yy599;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy708:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy709;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy710;
		goto yy46;
	}
yy709:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy710:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= '/') {
				if (yych <= ',') {
					if (yych <= '+') goto yy600;
					goto yy46;
				} else {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ';') {
					if (yych <= '9') goto yy710;
					if (yych <= ':') goto yy46;
					goto yy597;
				} else {
					if (yych == '@') goto yy599;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy712:
	yych = *++YYCURSOR;
	if (yych <= 'n') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy597;
				if (yych <= 0x00000008) goto yy46;
				if (yych <= '\r') goto yy597;
				goto yy46;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy597;
					goto yy46;
				} else {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 'Z') {
				if (yych <= '.') {
					if (yych <= '-') goto yy46;
					goto yy597;
				} else {
					if (yych == ';') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= '\\') {
					if (yych <= '[') goto yy597;
					goto yy46;
				} else {
					if (yych <= ']') goto yy597;
					if (yych <= 'm') goto yy46;
					goto yy753;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy597;
				if (yych <= 0x0000009F) goto yy46;
				goto yy597;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x0000180E) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00002029) goto yy597;
					if (yych <= 0x0000202E) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy713:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy749;
	goto yy46;
yy714:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy728;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy725;
					if (yych <= '9') goto yy714;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy729;
					if (yych == 'L') goto yy730;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy730;
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
				} else {
					if (yych <= 'f') goto yy729;
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy730;
					if (yych <= 'r') goto yy46;
					goto yy730;
				} else {
					if (yych == 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy597;
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy716:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '+') goto yy600;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy725;
				} else {
					if (yych <= '9') goto yy716;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
					goto yy716;
				} else {
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
					goto yy716;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy718:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy719:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy597;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy719;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych == '@') goto yy599;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy721;
					if (yych <= 'K') goto yy46;
				} else {
					if (yych == 'S') goto yy721;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy597;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy721;
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy721;
					if (yych <= 'r') goto yy46;
				} else {
					if (yych == 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy597;
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy721:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy722;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy723;
		goto yy46;
	}
yy722:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy723:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy600;
				} else {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy723;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy597;
					goto yy46;
				} else {
					if (yych <= '@') goto yy599;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy725:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy46;
		if (yych >= ':') goto yy46;
	} else {
		if (yych <= 'F') goto yy726;
		if (yych <= '`') goto yy46;
		if (yych >= 'g') goto yy46;
	}
yy726:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '+') goto yy600;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				} else {
					if (yych <= '9') goto yy726;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
					goto yy726;
				} else {
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
					goto yy726;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy728:
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= '\\') {
		if (yych <= '/') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy740;
					if (yych <= 0x00000008) goto yy598;
					goto yy740;
				} else {
					if (yych == ' ') goto yy740;
					if (yych <= '!') goto yy598;
					goto yy740;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy598;
					if (yych <= ')') goto yy740;
					goto yy598;
				} else {
					if (yych == ',') goto yy598;
					if (yych <= '.') goto yy740;
					goto yy598;
				}
			}
		} else {
			if (yych <= 'F') {
				if (yych <= ';') {
					if (yych == ':') goto yy598;
					goto yy740;
				} else {
					if (yych == '@') goto yy740;
					if (yych <= 'C') goto yy598;
					goto yy741;
				}
			} else {
				if (yych <= 'R') {
					if (yych == 'L') goto yy741;
					goto yy598;
				} else {
					if (yych <= 'S') goto yy741;
					if (yych == '[') goto yy740;
					goto yy598;
				}
			}
		}
	} else {
		if (yych <= 0x0000167F) {
			if (yych <= 'l') {
				if (yych <= 'f') {
					if (yych <= ']') goto yy740;
					if (yych <= 'c') goto yy598;
					goto yy741;
				} else {
					if (yych == 'i') goto yy740;
					if (yych <= 'k') goto yy598;
					goto yy741;
				}
			} else {
				if (yych <= 0x00000084) {
					if (yych == 's') goto yy741;
					goto yy598;
				} else {
					if (yych <= 0x00000085) goto yy740;
					if (yych == 0x000000A0) goto yy740;
					goto yy598;
				}
			}
		} else {
			if (yych <= 0x00002029) {
				if (yych <= 0x0000180E) {
					if (yych <= 0x00001680) goto yy740;
					if (yych <= 0x0000180D) goto yy598;
					goto yy740;
				} else {
					if (yych <= 0x00001FFF) goto yy598;
					if (yych <= 0x0000200A) goto yy740;
					if (yych <= 0x00002027) goto yy598;
					goto yy740;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych == 0x0000202F) goto yy740;
					goto yy598;
				} else {
					if (yych <= 0x0000205F) goto yy740;
					if (yych == 0x00003000) goto yy740;
					goto yy598;
				}
			}
		}
	}
yy729:
	yych = *++YYCURSOR;
	if (yych == '+') goto yy736;
	if (yych == '-') goto yy736;
	goto yy735;
yy730:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy731;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy732;
		goto yy46;
	}
yy731:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy732:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy600;
				} else {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy732;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy597;
					goto yy46;
				} else {
					if (yych <= '@') goto yy599;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy734:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy735:
	if (yych <= '\\') {
		if (yych <= ',') {
			if (yych <= '!') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= ')') {
					if (yych <= '#') goto yy597;
					if (yych <= '\'') goto yy46;
					goto yy597;
				} else {
					if (yych == '+') goto yy600;
					goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych <= '/') {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy725;
				} else {
					if (yych <= '9') goto yy734;
					if (yych <= ':') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 'F') {
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
					goto yy716;
				} else {
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= 'f') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
					goto yy716;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy736:
	yych = *++YYCURSOR;
	if (yych <= 'F') {
		if (yych <= '/') {
			if (yych == '.') goto yy607;
			goto yy46;
		} else {
			if (yych <= '9') goto yy737;
			if (yych <= '@') goto yy46;
			goto yy605;
		}
	} else {
		if (yych <= 'h') {
			if (yych <= '`') goto yy46;
			if (yych <= 'f') goto yy605;
			goto yy46;
		} else {
			if (yych <= 'i') goto yy601;
			if (yych == 'n') goto yy602;
			goto yy46;
		}
	}
yy737:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy701;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy615;
					if (yych <= '9') goto yy737;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					if (yych <= '@') goto yy599;
					goto yy605;
				}
			} else {
				if (yych <= 'R') {
					if (yych <= 'F') goto yy619;
					if (yych == 'L') goto yy620;
					goto yy46;
				} else {
					if (yych <= 'S') goto yy620;
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych <= ']') goto yy597;
					if (yych <= '`') goto yy46;
					goto yy605;
				} else {
					if (yych <= 'f') goto yy619;
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy620;
					if (yych <= 'r') goto yy46;
					goto yy620;
				} else {
					if (yych == 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy597;
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy739:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
yy740:
	if (yych <= '[') {
		if (yych <= '.') {
			if (yych <= '#') {
				if (yych <= '\r') {
					if (yych <= 0x00000000) goto yy597;
					if (yych <= 0x00000008) goto yy46;
					goto yy597;
				} else {
					if (yych == ' ') goto yy597;
					if (yych <= '!') goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '*') {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				} else {
					if (yych == ',') goto yy46;
					if (yych <= '-') goto yy600;
					goto yy597;
				}
			}
		} else {
			if (yych <= 'C') {
				if (yych <= ':') {
					if (yych <= '/') goto yy46;
					if (yych <= '9') goto yy739;
					goto yy46;
				} else {
					if (yych <= ';') goto yy597;
					if (yych == '@') goto yy599;
					goto yy46;
				}
			} else {
				if (yych <= 'L') {
					if (yych <= 'F') goto yy745;
					if (yych <= 'K') goto yy46;
					goto yy745;
				} else {
					if (yych == 'S') goto yy745;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x000000A0) {
			if (yych <= 'k') {
				if (yych <= 'c') {
					if (yych == ']') goto yy597;
					goto yy46;
				} else {
					if (yych <= 'f') goto yy745;
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 's') {
					if (yych <= 'l') goto yy745;
					if (yych <= 'r') goto yy46;
					goto yy745;
				} else {
					if (yych == 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x00002027) {
				if (yych <= 0x0000180D) {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					if (yych <= 0x0000200A) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205E) {
					if (yych <= 0x00002029) goto yy597;
					if (yych == 0x0000202F) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x0000205F) goto yy597;
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy741:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy742;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy743;
		goto yy46;
	}
yy742:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy743:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy600;
				} else {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy743;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy597;
					goto yy46;
				} else {
					if (yych <= '@') goto yy599;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy745:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy46;
	} else {
		if (yych <= '-') goto yy746;
		if (yych <= '/') goto yy46;
		if (yych <= '9') goto yy747;
		goto yy46;
	}
yy746:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy46;
	if (yych >= ':') goto yy46;
yy747:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if (yych <= '[') {
		if (yych <= '+') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '\'') {
					if (yych <= '!') goto yy46;
					if (yych <= '#') goto yy597;
					goto yy46;
				} else {
					if (yych <= ')') goto yy597;
					if (yych <= '*') goto yy46;
					goto yy600;
				}
			}
		} else {
			if (yych <= '9') {
				if (yych <= '-') {
					if (yych <= ',') goto yy46;
					goto yy600;
				} else {
					if (yych <= '.') goto yy597;
					if (yych <= '/') goto yy46;
					goto yy747;
				}
			} else {
				if (yych <= '?') {
					if (yych == ';') goto yy597;
					goto yy46;
				} else {
					if (yych <= '@') goto yy599;
					if (yych <= 'Z') goto yy46;
					goto yy597;
				}
			}
		}
	} else {
		if (yych <= 0x0000180D) {
			if (yych <= 0x00000084) {
				if (yych <= ']') {
					if (yych <= '\\') goto yy46;
					goto yy597;
				} else {
					if (yych == 'i') goto yy611;
					goto yy46;
				}
			} else {
				if (yych <= 0x000000A0) {
					if (yych <= 0x00000085) goto yy597;
					if (yych <= 0x0000009F) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00001680) goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x0000180E) goto yy597;
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy749:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '0') goto yy46;
yy752:
	yych = *++YYCURSOR;
	if (yych <= '\\') {
		if (yych <= '*') {
			if (yych <= ' ') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy597;
					goto yy46;
				} else {
					if (yych <= '\r') goto yy597;
					if (yych <= 0x0000001F) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= '#') {
					if (yych <= '!') goto yy46;
					goto yy597;
				} else {
					if (yych <= '\'') goto yy46;
					if (yych <= ')') goto yy597;
					goto yy46;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ',') {
					if (yych <= '+') goto yy600;
					goto yy46;
				} else {
					if (yych <= '-') goto yy600;
					if (yych <= '.') goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= '@') {
					if (yych <= ';') goto yy597;
					if (yych <= '?') goto yy46;
					goto yy599;
				} else {
					if (yych == '[') goto yy597;
					goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000180E) {
			if (yych <= 0x00000085) {
				if (yych <= 'h') {
					if (yych <= ']') goto yy597;
					goto yy46;
				} else {
					if (yych <= 'i') goto yy611;
					if (yych <= 0x00000084) goto yy46;
					goto yy597;
				}
			} else {
				if (yych <= 0x0000167F) {
					if (yych == 0x000000A0) goto yy597;
					goto yy46;
				} else {
					if (yych <= 0x00001680) goto yy597;
					if (yych <= 0x0000180D) goto yy46;
					goto yy597;
				}
			}
		} else {
			if (yych <= 0x0000202E) {
				if (yych <= 0x0000200A) {
					if (yych <= 0x00001FFF) goto yy46;
					goto yy597;
				} else {
					if (yych <= 0x00002027) goto yy46;
					if (yych <= 0x00002029) goto yy597;
					goto yy46;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000202F) goto yy597;
					if (yych <= 0x0000205E) goto yy46;
					goto yy597;
				} else {
					if (yych == 0x00003000) goto yy597;
					goto yy46;
				}
			}
		}
	}
yy753:
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '.') goto yy46;
	yych = *++YYCURSOR;
	if (yych == '0') goto yy752;
	goto yy46;
yy756:
	yych = *++YYCURSOR;
	if (yych <= 'I') {
		if (yych == 'E') goto yy587;
		if (yych <= 'H') goto yy46;
		goto yy587;
	} else {
		if (yych <= 'e') {
			if (yych <= 'd') goto yy46;
			goto yy587;
		} else {
			if (yych == 'i') goto yy587;
			goto yy46;
		}
	}
yy757:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '/') goto yy762;
	if (yych == '\\') goto yy757;
	goto yy357;
yy759:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy760;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy760;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy760;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy760;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy760;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy760;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy760:
	++YYCURSOR;
yy761:
#line 386 "src/scanner.re"
	{
            YYCURSOR--;
            yylval->stringValue = ucs4string(YYTOKEN + 2, (YYCURSOR - YYTOKEN) - 3);
            YYTOKEN = YYCURSOR;
            return REGEXP;
        }
#line 17530 "<stdout>"
yy762:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy763;
				if (yych <= 0x00000008) goto yy357;
				if (yych >= 0x0000000E) goto yy357;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy357;
				} else {
					if (yych <= '#') goto yy763;
					if (yych <= '\'') goto yy357;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= '-') goto yy357;
				if (yych <= '.') goto yy763;
				if (yych <= '/') goto yy759;
				goto yy357;
			} else {
				if (yych <= 'Z') {
					if (yych >= '<') goto yy357;
				} else {
					if (yych == '\\') goto yy757;
				}
			}
		}
	} else {
		if (yych <= 0x00001FFF) {
			if (yych <= 0x000000A0) {
				if (yych == 0x00000085) goto yy763;
				if (yych <= 0x0000009F) goto yy357;
			} else {
				if (yych <= 0x00001680) {
					if (yych <= 0x0000167F) goto yy357;
				} else {
					if (yych != 0x0000180E) goto yy357;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) {
					if (yych >= 0x0000200B) goto yy357;
				} else {
					if (yych <= 0x00002029) goto yy763;
					if (yych <= 0x0000202E) goto yy357;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy357;
				} else {
					if (yych != 0x00003000) goto yy357;
				}
			}
		}
	}
yy763:
	yyaccept = 7;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '/') goto yy759;
	if (yych == '\\') goto yy757;
	goto yy357;
yy764:
	++YYCURSOR;
#line 421 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_SYNTAX; }
#line 17607 "<stdout>"
yy766:
	++YYCURSOR;
#line 425 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_QUASISYNTAX; }
#line 17615 "<stdout>"
yy768:
	++YYCURSOR;
#line 429 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAX;
        }
#line 17624 "<stdout>"
yy770:
	yych = *++YYCURSOR;
	++YYCURSOR;
#line 434 "src/scanner.re"
	{
            YYCURSOR--;
            YYTOKEN = YYCURSOR;
            return ABBV_UNSYNTAXSPLICING;
        }
#line 17634 "<stdout>"
yy773:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
yy774:
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy779;
			goto yy773;
		} else {
			if (yych <= '\n') goto yy779;
			if (yych <= '\f') goto yy773;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy773;
			goto yy778;
		} else {
			if (yych == 0x00002028) goto yy778;
			goto yy773;
		}
	}
yy775:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy782;
					goto yy773;
				} else {
					if (yych == '\n') goto yy782;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy784;
					goto yy773;
				} else {
					if (yych == '!') goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy773;
					goto yy783;
				} else {
					if (yych == '.') goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy783;
					goto yy773;
				} else {
					if (yych == '\\') goto yy773;
					goto yy783;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy773;
					goto yy786;
				} else {
					if (yych == 0x000000A0) goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy783;
					goto yy773;
				} else {
					if (yych <= 0x0000180E) goto yy783;
					if (yych <= 0x00001FFF) goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy773;
					goto yy786;
				} else {
					if (yych <= 0x00002029) goto yy783;
					if (yych <= 0x0000202E) goto yy773;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy773;
					goto yy783;
				} else {
					if (yych == 0x00003000) goto yy783;
					goto yy773;
				}
			}
		}
	}
yy776:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '\f') {
			if (yych <= 0x00000000) goto yy779;
			if (yych == '\n') goto yy779;
			goto yy773;
		} else {
			if (yych <= ',') {
				if (yych <= '\r') goto yy775;
				goto yy773;
			} else {
				if (yych <= '9') goto yy776;
				if (yych <= '@') goto yy773;
				goto yy776;
			}
		}
	} else {
		if (yych <= 'z') {
			if (yych == '_') goto yy776;
			if (yych <= '`') goto yy773;
			goto yy776;
		} else {
			if (yych <= 0x00000085) {
				if (yych <= 0x00000084) goto yy773;
			} else {
				if (yych != 0x00002028) goto yy773;
			}
		}
	}
yy778:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy782;
					goto yy773;
				} else {
					if (yych == '\n') goto yy782;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy784;
					goto yy773;
				} else {
					if (yych == '!') goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy773;
					goto yy783;
				} else {
					if (yych == '.') goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy783;
					goto yy773;
				} else {
					if (yych == '\\') goto yy773;
					goto yy783;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy773;
					goto yy786;
				} else {
					if (yych == 0x000000A0) goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy783;
					goto yy773;
				} else {
					if (yych <= 0x0000180E) goto yy783;
					if (yych <= 0x00001FFF) goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy773;
					goto yy786;
				} else {
					if (yych <= 0x00002029) goto yy783;
					if (yych <= 0x0000202E) goto yy773;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy773;
					goto yy783;
				} else {
					if (yych == 0x00003000) goto yy783;
					goto yy773;
				}
			}
		}
	}
yy779:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy780;
				if (yych <= 0x00000008) goto yy46;
				if (yych >= 0x0000000E) goto yy46;
			} else {
				if (yych <= '!') {
					if (yych >= '!') goto yy46;
				} else {
					if (yych <= '#') goto yy780;
					if (yych <= '\'') goto yy46;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy780;
				if (yych <= ':') goto yy46;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy46;
				} else {
					if (yych != ']') goto yy46;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy780;
				if (yych != 0x000000A0) goto yy46;
			} else {
				if (yych <= 0x0000180D) {
					if (yych >= 0x00001681) goto yy46;
				} else {
					if (yych <= 0x0000180E) goto yy780;
					if (yych <= 0x00001FFF) goto yy46;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy46;
				if (yych <= 0x00002029) goto yy780;
				if (yych <= 0x0000202E) goto yy46;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy46;
				} else {
					if (yych != 0x00003000) goto yy46;
				}
			}
		}
	}
yy780:
	++YYCURSOR;
yy781:
#line 235 "src/scanner.re"
	{
            YYCURSOR--;
            ucs4string shebang(YYTOKEN, YYCURSOR - YYTOKEN - 1);
            if (shebang == ucs4string(UC("#!r6rs"))) {
                currentVM()->readerContext()->port()->setStrictR6RsReaderMode();
            } else {
                 // just ignore the shebang.
            }
            YYTOKEN = YYCURSOR;
            continue;
       }
#line 17926 "<stdout>"
yy782:
	yych = *++YYCURSOR;
	if (yych <= 0x00000084) {
		if (yych <= ')') {
			if (yych <= 0x0000001F) {
				if (yych <= 0x00000000) goto yy780;
				if (yych <= 0x00000008) goto yy781;
				if (yych <= '\r') goto yy780;
				goto yy781;
			} else {
				if (yych <= '!') {
					if (yych <= ' ') goto yy780;
					goto yy781;
				} else {
					if (yych <= '#') goto yy780;
					if (yych <= '\'') goto yy781;
					goto yy780;
				}
			}
		} else {
			if (yych <= ';') {
				if (yych == '.') goto yy780;
				if (yych <= ':') goto yy781;
				goto yy780;
			} else {
				if (yych <= '[') {
					if (yych <= 'Z') goto yy781;
					goto yy780;
				} else {
					if (yych == ']') goto yy780;
					goto yy781;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) goto yy780;
				if (yych == 0x000000A0) goto yy780;
				goto yy781;
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy780;
					goto yy781;
				} else {
					if (yych <= 0x0000180E) goto yy780;
					if (yych <= 0x00001FFF) goto yy781;
					goto yy780;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002027) goto yy781;
				if (yych <= 0x00002029) goto yy780;
				if (yych <= 0x0000202E) goto yy781;
				goto yy780;
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy781;
					goto yy780;
				} else {
					if (yych == 0x00003000) goto yy780;
					goto yy781;
				}
			}
		}
	}
yy783:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '\r') {
		if (yych <= '\t') {
			if (yych <= 0x00000000) goto yy779;
			goto yy773;
		} else {
			if (yych <= '\n') goto yy779;
			if (yych <= '\f') goto yy773;
			goto yy775;
		}
	} else {
		if (yych <= 0x00000085) {
			if (yych <= 0x00000084) goto yy773;
			goto yy778;
		} else {
			if (yych == 0x00002028) goto yy778;
			goto yy773;
		}
	}
yy784:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy782;
					goto yy773;
				} else {
					if (yych == '\n') goto yy782;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy784;
					goto yy773;
				} else {
					if (yych == '!') goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy773;
					goto yy783;
				} else {
					if (yych == '.') goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy783;
					goto yy773;
				} else {
					if (yych == '\\') goto yy773;
					goto yy783;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy773;
				} else {
					if (yych == 0x000000A0) goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy783;
					goto yy773;
				} else {
					if (yych <= 0x0000180E) goto yy783;
					if (yych <= 0x00001FFF) goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy773;
				} else {
					if (yych <= 0x00002029) goto yy783;
					if (yych <= 0x0000202E) goto yy773;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy773;
					goto yy783;
				} else {
					if (yych == 0x00003000) goto yy783;
					goto yy773;
				}
			}
		}
	}
yy786:
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= ']') {
		if (yych <= '#') {
			if (yych <= '\f') {
				if (yych <= 0x00000008) {
					if (yych <= 0x00000000) goto yy782;
					goto yy773;
				} else {
					if (yych == '\n') goto yy782;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000001F) {
					if (yych <= '\r') goto yy784;
					goto yy773;
				} else {
					if (yych == '!') goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= ':') {
				if (yych <= ')') {
					if (yych <= '\'') goto yy773;
					goto yy783;
				} else {
					if (yych == '.') goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 'Z') {
					if (yych <= ';') goto yy783;
					goto yy773;
				} else {
					if (yych == '\\') goto yy773;
					goto yy783;
				}
			}
		}
	} else {
		if (yych <= 0x0000200A) {
			if (yych <= 0x0000167F) {
				if (yych <= 0x00000085) {
					if (yych <= 0x00000084) goto yy773;
					goto yy786;
				} else {
					if (yych == 0x000000A0) goto yy783;
					goto yy773;
				}
			} else {
				if (yych <= 0x0000180D) {
					if (yych <= 0x00001680) goto yy783;
					goto yy773;
				} else {
					if (yych <= 0x0000180E) goto yy783;
					if (yych <= 0x00001FFF) goto yy773;
					goto yy783;
				}
			}
		} else {
			if (yych <= 0x0000202F) {
				if (yych <= 0x00002028) {
					if (yych <= 0x00002027) goto yy773;
					goto yy786;
				} else {
					if (yych <= 0x00002029) goto yy783;
					if (yych <= 0x0000202E) goto yy773;
					goto yy783;
				}
			} else {
				if (yych <= 0x0000205F) {
					if (yych <= 0x0000205E) goto yy773;
					goto yy783;
				} else {
					if (yych == 0x00003000) goto yy783;
					goto yy773;
				}
			}
		}
	}
yy788:
	yych = *++YYCURSOR;
	if (yych != '8') goto yy46;
	yych = *++YYCURSOR;
	if (yych != '(') goto yy46;
	++YYCURSOR;
#line 457 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return BYTE_VECTOR_START;
        }
#line 18194 "<stdout>"
}
#line 482 "src/scanner.re"


comment:
        YYTOKEN = YYCURSOR;

#line 18202 "<stdout>"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '#') {
		if (yych <= 0x00000000) goto yy797;
		if (yych <= '"') goto yy799;
		goto yy796;
	} else {
		if (yych != '|') goto yy799;
	}
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '#') goto yy802;
yy795:
#line 504 "src/scanner.re"
	{
            goto comment;
        }
#line 18221 "<stdout>"
yy796:
	yych = *++YYCURSOR;
	if (yych == '|') goto yy800;
	goto yy795;
yy797:
	++YYCURSOR;
#line 499 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            return 0;
        }
#line 18233 "<stdout>"
yy799:
	yych = *++YYCURSOR;
	goto yy795;
yy800:
	++YYCURSOR;
#line 495 "src/scanner.re"
	{
            comment_count++;
            goto comment;
        }
#line 18244 "<stdout>"
yy802:
	++YYCURSOR;
#line 487 "src/scanner.re"
	{
            YYTOKEN = YYCURSOR;
            if (--comment_count == 0) {
                continue;
            } else {
                goto comment;
            }
        }
#line 18256 "<stdout>"
}
#line 507 "src/scanner.re"

    }
}

ucs4string Scanner::currentToken() const
{
    if (limit_ >= token_) {
        return ucs4string(token_, limit_ - token_);
    } else {
        return ucs4string(UC(""));
    }
}
